# Code generated by smithy-python-codegen DO NOT EDIT.

from smithy_core.prelude import (
    BOOLEAN,
    DOCUMENT,
    INTEGER,
    LONG,
    STRING,
    TIMESTAMP,
    UNIT,
)
from smithy_core.schemas import Schema
from smithy_core.shapes import ShapeID, ShapeType
from smithy_core.traits import Trait


ACCOUNT_ID = Schema(
    id=ShapeID("borneo#AccountId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

ACCOUNT_NAME = Schema(
    id=ShapeID("borneo#AccountName"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9.,_ @+=-]{1,100}$"),
    ],
)

UNIQUE_STRING_LIST = Schema.collection(
    id=ShapeID("borneo#UniqueStringList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": STRING,
        },
    },
)

ACCOUNT_PERMISSIONS = Schema.collection(
    id=ShapeID("borneo#AccountPermissions"),
    members={
        "enableInventoryPolicy": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "enableAwsConfigPolicy": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "enableDataplaneDeployPolicy": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "enableDpCli": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "regions": {
            "target": UNIQUE_STRING_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "addEventBridgePermission": {
            "target": BOOLEAN,
        },
    },
)

ACCOUNT_STATUS = Schema.collection(
    id=ShapeID("borneo#AccountStatus"),
    type=ShapeType.ENUM,
    members={
        "NEW": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NEW"),
            ],
        },
        "VALIDATED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="VALIDATED"),
            ],
        },
        "VALIDATION_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="VALIDATION_FAILED"),
            ],
        },
        "DELETING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DELETING"),
            ],
        },
        "DELETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DELETED"),
            ],
        },
    },
)

ACCOUNT_TYPE = Schema.collection(
    id=ShapeID("borneo#AccountType"),
    type=ShapeType.ENUM,
    members={
        "AWS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AWS"),
            ],
        },
    },
)

DATA_PLANE_ID = Schema(
    id=ShapeID("borneo#DataPlaneId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

DATA_PLANE_IDS = Schema.collection(
    id=ShapeID("borneo#DataPlaneIds"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DATA_PLANE_ID,
        },
    },
)

DESCRIBE_ACCOUNT_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeAccountInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "accountId": {
            "target": ACCOUNT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

OPEN_PROPERTIES = Schema.collection(
    id=ShapeID("borneo#OpenProperties"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": DOCUMENT,
        },
    },
)

DESCRIBE_ACCOUNT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeAccountOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "accountId": {
            "target": ACCOUNT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": ACCOUNT_NAME,
        },
        "cloudAccountId": {
            "target": STRING,
        },
        "dataPlaneIds": {
            "target": DATA_PLANE_IDS,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "type": {
            "target": ACCOUNT_TYPE,
        },
        "status": {
            "target": ACCOUNT_STATUS,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "deletedAt": {
            "target": TIMESTAMP,
        },
        "permissions": {
            "target": ACCOUNT_PERMISSIONS,
        },
    },
)

NO_SUCH_RESOURCE = Schema.collection(
    id=ShapeID("borneo#NoSuchResource"),
    traits=[
        Trait(id=ShapeID("smithy.api#httpError"), value=404),
    ],
    members={
        "resourceType": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UNAUTHORIZED = Schema.collection(
    id=ShapeID("borneo#Unauthorized"),
    traits=[
        Trait(id=ShapeID("smithy.api#httpError"), value=401),
    ],
    members={
        "message": {
            "target": STRING,
        },
    },
)

UNEXPECTED_SERVER_ERROR = Schema.collection(
    id=ShapeID("borneo#UnexpectedServerError"),
    traits=[
        Trait(id=ShapeID("smithy.api#httpError"), value=500),
    ],
    members={
        "message": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

VALIDATION_EXCEPTION_FIELD = Schema.collection(
    id=ShapeID("smithy.framework#ValidationExceptionField"),
    members={
        "path": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "message": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

VALIDATION_EXCEPTION_FIELD_LIST = Schema.collection(
    id=ShapeID("smithy.framework#ValidationExceptionFieldList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": VALIDATION_EXCEPTION_FIELD,
        },
    },
)

VALIDATION_EXCEPTION = Schema.collection(
    id=ShapeID("smithy.framework#ValidationException"),
    members={
        "message": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "fieldList": {
            "target": VALIDATION_EXCEPTION_FIELD_LIST,
        },
    },
)

DESCRIBE_CLOUD_ACCOUNT_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeCloudAccountInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "cloudAccountId": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_CLOUD_ACCOUNT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeCloudAccountOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "accountId": {
            "target": ACCOUNT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": ACCOUNT_NAME,
        },
        "cloudAccountId": {
            "target": STRING,
        },
        "dataPlaneIds": {
            "target": DATA_PLANE_IDS,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "type": {
            "target": ACCOUNT_TYPE,
        },
        "status": {
            "target": ACCOUNT_STATUS,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "deletedAt": {
            "target": TIMESTAMP,
        },
        "permissions": {
            "target": ACCOUNT_PERMISSIONS,
        },
    },
)

ACCOUNT_FILTER = Schema.collection(
    id=ShapeID("borneo#AccountFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "status": {
            "target": UNIQUE_STRING_LIST,
        },
        "accountId": {
            "target": UNIQUE_STRING_LIST,
        },
        "cloudAccountId": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

PAGE_SIZE = Schema(
    id=ShapeID("borneo#PageSize"),
    type=ShapeType.INTEGER,
    traits=[
        Trait(id=ShapeID("smithy.api#box")),
        Trait(
            id=ShapeID("smithy.api#range"),
            value={
                "min": 1,
                "max": 10000,
            },
        ),
    ],
)

COLUMN_NAME = Schema(
    id=ShapeID("borneo#ColumnName"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9_]+$"),
    ],
)

SORT_ORDER = Schema.collection(
    id=ShapeID("borneo#SortOrder"),
    type=ShapeType.ENUM,
    members={
        "ASC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ASC"),
            ],
        },
        "DESC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DESC"),
            ],
        },
    },
)

SORT_RECORDS = Schema.collection(
    id=ShapeID("borneo#SortRecords"),
    members={
        "column": {
            "target": COLUMN_NAME,
        },
        "order": {
            "target": SORT_ORDER,
        },
    },
)

LIST_ACCOUNTS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListAccountsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": ACCOUNT_FILTER,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "nextToken": {
            "target": STRING,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

ACCOUNT_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#AccountListMember"),
    members={
        "accountId": {
            "target": ACCOUNT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": ACCOUNT_NAME,
        },
        "cloudAccountId": {
            "target": STRING,
        },
        "dataPlaneIds": {
            "target": DATA_PLANE_IDS,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "type": {
            "target": ACCOUNT_TYPE,
        },
        "status": {
            "target": ACCOUNT_STATUS,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "deletedAt": {
            "target": TIMESTAMP,
        },
        "permissions": {
            "target": ACCOUNT_PERMISSIONS,
        },
    },
)

ACCOUNTS_LIST = Schema.collection(
    id=ShapeID("borneo#AccountsList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": ACCOUNT_LIST_MEMBER,
        },
    },
)

LIST_ACCOUNTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListAccountsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "accounts": {
            "target": ACCOUNTS_LIST,
        },
        "total": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

UUID = Schema(
    id=ShapeID("borneo#Uuid"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

UUID_COLLECTION = Schema.collection(
    id=ShapeID("borneo#UuidCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": UUID,
        },
    },
)

ADD_DISCOVERED_RECIPIENT_AS_RECIPIENTS_INPUT = Schema.collection(
    id=ShapeID("borneo#AddDiscoveredRecipientAsRecipientsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "discoveredRecipientIds": {
            "target": UUID_COLLECTION,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

ADD_DISCOVERED_RECIPIENT_AS_RECIPIENTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#AddDiscoveredRecipientAsRecipientsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "recipientIds": {
            "target": UUID_COLLECTION,
        },
    },
)

ARCHIVE_DISCOVERED_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#ArchiveDiscoveredRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "discoveredRecipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

ARCHIVE_DISCOVERED_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ArchiveDiscoveredRecipientOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

ASSET_ID = Schema(
    id=ShapeID("borneo#AssetId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

LOCATION_TYPE = Schema.collection(
    id=ShapeID("borneo#LocationType"),
    type=ShapeType.ENUM,
    members={
        "EXTERNAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="external"),
            ],
        },
        "REMOTE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="remote"),
            ],
        },
        "OFFICE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="office"),
            ],
        },
    },
)

TYPE = Schema.collection(
    id=ShapeID("borneo#Type"),
    type=ShapeType.ENUM,
    members={
        "APPLICATIONS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="applications"),
            ],
        },
        "CLOUDSERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cloudServices"),
            ],
        },
        "COMMUNICATIONS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="communications"),
            ],
        },
        "DATAINFORMATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dataInformation"),
            ],
        },
        "EXTERNALSTORAGE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="externalStorage"),
            ],
        },
        "HARDWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="hardware"),
            ],
        },
        "HOSTING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="hosting"),
            ],
        },
        "FURNITURE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="furniture"),
            ],
        },
        "OTHER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="other"),
            ],
        },
        "PAPERDOCUMENTATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="paperDocumentation"),
            ],
        },
        "PRINTER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="printer"),
            ],
        },
        "SERVER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="server"),
            ],
        },
        "SHREDDER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="shredder"),
            ],
        },
        "VIDEOSURVEILLANCE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="videoSurveillance"),
            ],
        },
        "FILINGROOM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="filingRoom"),
            ],
        },
    },
)

CREATE_ASSET_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateAssetInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "type": {
            "target": TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tomIds": {
            "target": UUID_COLLECTION,
        },
        "locationType": {
            "target": LOCATION_TYPE,
        },
        "locationId": {
            "target": UUID,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
    },
)

CREATE_ASSET_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateAssetOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

NOT_ALLOWED = Schema.collection(
    id=ShapeID("borneo#NotAllowed"),
    traits=[
        Trait(id=ShapeID("smithy.api#httpError"), value=403),
    ],
    members={
        "message": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_ASSET_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeAssetInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

PHYSICAL_ADDRESS = Schema(
    id=ShapeID("borneo#PhysicalAddress"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 500,
            },
        ),
    ],
)

HEADQUARTER_CITY = Schema(
    id=ShapeID("borneo#HeadquarterCity"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 100,
            },
        ),
    ],
)

COUNTRY_CODE = Schema(
    id=ShapeID("borneo#CountryCode"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Z]{2}$"),
    ],
)

HEADQUARTER_ID = Schema(
    id=ShapeID("borneo#HeadquarterId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

HEADQUARTER_NAME = Schema(
    id=ShapeID("borneo#HeadquarterName"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9.,_ @+=-]{1,100}$"),
    ],
)

TOM_CATEGORY = Schema(
    id=ShapeID("borneo#TomCategory"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 200,
            },
        ),
    ],
)

TOM_DESCRIPTION = Schema(
    id=ShapeID("borneo#TomDescription"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 1000,
            },
        ),
    ],
)

TOM_LIST = Schema(
    id=ShapeID("borneo#TomList"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 200,
            },
        ),
    ],
)

TOM_NAME = Schema(
    id=ShapeID("borneo#TomName"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 500,
            },
        ),
    ],
)

TOM_NOTE = Schema(
    id=ShapeID("borneo#TomNote"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 3000,
            },
        ),
    ],
)

TOM_REFERENCE_CODE = Schema(
    id=ShapeID("borneo#TomReferenceCode"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 200,
            },
        ),
    ],
)

TOM_STATUS = Schema.collection(
    id=ShapeID("borneo#TomStatus"),
    type=ShapeType.ENUM,
    members={
        "IMPLEMENTED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="implemented"),
            ],
        },
        "AVAILABLE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="available"),
            ],
        },
        "PENDING_TO_IMPLEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="pendingToImplement"),
            ],
        },
    },
)

TOM_ID = Schema(
    id=ShapeID("borneo#TomId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 80,
            },
        ),
    ],
)

TOM_TYPE = Schema.collection(
    id=ShapeID("borneo#TomType"),
    type=ShapeType.ENUM,
    members={
        "ORGANISATIONAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="organisational"),
            ],
        },
        "TECHNICAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="technical"),
            ],
        },
    },
)

TOM_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#TomListMember"),
    members={
        "tomId": {
            "target": TOM_ID,
        },
        "name": {
            "target": TOM_NAME,
        },
        "description": {
            "target": TOM_DESCRIPTION,
        },
        "list": {
            "target": TOM_LIST,
        },
        "category": {
            "target": TOM_CATEGORY,
        },
        "type": {
            "target": TOM_TYPE,
        },
        "referenceCode": {
            "target": TOM_REFERENCE_CODE,
        },
        "status": {
            "target": TOM_STATUS,
        },
        "note": {
            "target": TOM_NOTE,
        },
    },
)

TOM_COLLECTION = Schema.collection(
    id=ShapeID("borneo#TomCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": TOM_LIST_MEMBER,
        },
    },
)

ZIP_CODE = Schema(
    id=ShapeID("borneo#ZipCode"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 15,
            },
        ),
    ],
)

HEADQUARTER_RECORD = Schema.collection(
    id=ShapeID("borneo#HeadquarterRecord"),
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": HEADQUARTER_NAME,
        },
        "city": {
            "target": HEADQUARTER_CITY,
        },
        "address": {
            "target": PHYSICAL_ADDRESS,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "zipcode": {
            "target": ZIP_CODE,
        },
        "toms": {
            "target": TOM_COLLECTION,
        },
    },
)

DESCRIBE_ASSET_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeAssetOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"), value="borneo#AssetRecord"
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "type": {
            "target": TYPE,
        },
        "tomIds": {
            "target": UUID_COLLECTION,
        },
        "locationType": {
            "target": LOCATION_TYPE,
        },
        "locationId": {
            "target": UUID,
        },
        "toms": {
            "target": TOM_COLLECTION,
        },
        "location": {
            "target": HEADQUARTER_RECORD,
        },
    },
)

ASSET_SELECT_FILTER = Schema.collection(
    id=ShapeID("borneo#AssetSelectFilter"),
    members={
        "search": {
            "target": STRING,
        },
    },
)

LIST_ASSETS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListAssetsInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#AssetListInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "nextToken": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#httpQuery"), value="nextToken"),
            ],
        },
        "pageSize": {
            "target": PAGE_SIZE,
            "traits": [
                Trait(id=ShapeID("smithy.api#httpQuery"), value="maxResults"),
            ],
        },
        "filter": {
            "target": ASSET_SELECT_FILTER,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

ASSET_LIST_RECORD = Schema.collection(
    id=ShapeID("borneo#AssetListRecord"),
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "type": {
            "target": TYPE,
        },
        "locationType": {
            "target": LOCATION_TYPE,
        },
        "toms": {
            "target": TOM_COLLECTION,
        },
        "location": {
            "target": HEADQUARTER_RECORD,
        },
    },
)

ASSET_LIST = Schema.collection(
    id=ShapeID("borneo#AssetList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": ASSET_LIST_RECORD,
        },
    },
)

LIST_ASSETS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListAssetsOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#AssetListOutput",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "assets": {
            "target": ASSET_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "total": {
            "target": INTEGER,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

REMOVE_ASSET_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveAssetInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_ASSET_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveAssetOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_ASSET_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateAssetInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "type": {
            "target": TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tomIds": {
            "target": UUID_COLLECTION,
        },
        "locationType": {
            "target": LOCATION_TYPE,
        },
        "locationId": {
            "target": UUID,
        },
    },
)

UPDATE_ASSET_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateAssetOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

ASSET_RECORD = Schema.collection(
    id=ShapeID("borneo#AssetRecord"),
    members={
        "assetId": {
            "target": ASSET_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "type": {
            "target": TYPE,
        },
        "tomIds": {
            "target": UUID_COLLECTION,
        },
        "locationType": {
            "target": LOCATION_TYPE,
        },
        "locationId": {
            "target": UUID,
        },
        "toms": {
            "target": TOM_COLLECTION,
        },
        "location": {
            "target": HEADQUARTER_RECORD,
        },
    },
)

COMPLIANCE_DETAIL = Schema.collection(
    id=ShapeID("borneo#ComplianceDetail"),
    members={
        "name": {
            "target": STRING,
        },
        "compliant": {
            "target": BOOLEAN,
        },
        "infotypes": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

COMPLIANCE_DETAIL_LIST = Schema.collection(
    id=ShapeID("borneo#ComplianceDetailList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": COMPLIANCE_DETAIL,
        },
    },
)

RESOURCE_ID = Schema(
    id=ShapeID("borneo#ResourceId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

DESCRIBE_CATALOG_RESOURCE_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeCatalogResourceInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

OWNER_OBJECT = Schema.collection(
    id=ShapeID("borneo#OwnerObject"),
    members={
        "name": {
            "target": STRING,
        },
        "id": {
            "target": STRING,
        },
        "meta": {
            "target": DOCUMENT,
        },
    },
)

OWNER_OBJECT_LIST = Schema.collection(
    id=ShapeID("borneo#OwnerObjectList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": OWNER_OBJECT,
        },
    },
)

SAMPLE_TOKENS = Schema.collection(
    id=ShapeID("borneo#SampleTokens"),
    members={
        "token": {
            "target": STRING,
        },
        "infoType": {
            "target": STRING,
        },
        "column": {
            "target": INTEGER,
        },
        "columnName": {
            "target": STRING,
        },
        "row": {
            "target": INTEGER,
        },
    },
)

SAMPLE_TOKENS_LIST = Schema.collection(
    id=ShapeID("borneo#SampleTokensList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": SAMPLE_TOKENS,
        },
    },
)

TOKENS = Schema.collection(
    id=ShapeID("borneo#Tokens"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": SAMPLE_TOKENS_LIST,
        },
    },
)

INFOTYPE_SNAPSHOT = Schema.collection(
    id=ShapeID("borneo#InfotypeSnapshot"),
    members={
        "found": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "count": {
            "target": INTEGER,
        },
    },
)

INSPECTION_RESULT_SNAPSHOT = Schema.collection(
    id=ShapeID("borneo#InspectionResultSnapshot"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": INFOTYPE_SNAPSHOT,
        },
    },
)

SOURCE_OF_RESOURCE = Schema.collection(
    id=ShapeID("borneo#SourceOfResource"),
    type=ShapeType.ENUM,
    members={
        "DISCOVERED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="discovered"),
            ],
        },
        "MANUAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="manual_resource"),
            ],
        },
    },
)

RESOURCE_STATUS = Schema.collection(
    id=ShapeID("borneo#ResourceStatus"),
    type=ShapeType.ENUM,
    members={
        "NEW": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NEW"),
            ],
        },
        "VALIDATED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="VALIDATED"),
            ],
        },
        "VALIDATION_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="VALIDATION_FAILED"),
            ],
        },
        "ACTIVE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ACTIVE"),
            ],
        },
        "DEPLOYMENT_SUCCESS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DEPLOYMENT_SUCCESS"),
            ],
        },
        "DEPLOYMENT_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DEPLOYMENT_FAILED"),
            ],
        },
        "DELETING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DELETING"),
            ],
        },
        "DELETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DELETED"),
            ],
        },
        "CONNECTOR_DELETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="CONNECTOR_DELETED"),
            ],
        },
        "HOST_CONNECTIVITY_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="HOST_CONNECTIVITY_FAILED"
                ),
            ],
        },
        "CREDENTIAL_CHECK_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="CREDENTIAL_CHECK_FAILED"
                ),
            ],
        },
    },
)

DESCRIBE_CATALOG_RESOURCE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeCatalogResourceOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "owner": {
            "target": OWNER_OBJECT_LIST,
        },
        "status": {
            "target": RESOURCE_STATUS,
        },
        "parentId": {
            "target": STRING,
        },
        "source": {
            "target": SOURCE_OF_RESOURCE,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "sampleTokens": {
            "target": TOKENS,
        },
        "compliance": {
            "target": COMPLIANCE_DETAIL_LIST,
        },
        "lastScanned": {
            "target": TIMESTAMP,
        },
    },
)

INFO_TYPE_FILTER_OPERATION = Schema.collection(
    id=ShapeID("borneo#InfoTypeFilterOperation"),
    type=ShapeType.ENUM,
    members={
        "AND": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AND"),
            ],
        },
        "OR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="OR"),
            ],
        },
    },
)

INFO_TYPES_COMBINATION_FILTER = Schema.collection(
    id=ShapeID("borneo#InfoTypesCombinationFilter"),
    members={
        "infoTypes": {
            "target": UNIQUE_STRING_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "ops": {
            "target": INFO_TYPE_FILTER_OPERATION,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

LEAF_RESOURCE_FILTER = Schema.collection(
    id=ShapeID("borneo#LeafResourceFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "account": {
            "target": UNIQUE_STRING_LIST,
        },
        "instance": {
            "target": UNIQUE_STRING_LIST,
        },
        "database": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataset": {
            "target": UNIQUE_STRING_LIST,
        },
        "schema": {
            "target": UNIQUE_STRING_LIST,
        },
        "driveId": {
            "target": UNIQUE_STRING_LIST,
        },
        "orgUnitId": {
            "target": UNIQUE_STRING_LIST,
        },
        "driveType": {
            "target": UNIQUE_STRING_LIST,
        },
        "region": {
            "target": UNIQUE_STRING_LIST,
        },
        "status": {
            "target": UNIQUE_STRING_LIST,
        },
        "parentId": {
            "target": STRING,
        },
        "resourceId": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceType": {
            "target": UNIQUE_STRING_LIST,
        },
        "scanned": {
            "target": BOOLEAN,
        },
        "infoTypes": {
            "target": INFO_TYPES_COMBINATION_FILTER,
        },
        "classification": {
            "target": UNIQUE_STRING_LIST,
        },
        "categories": {
            "target": UNIQUE_STRING_LIST,
        },
        "spaceStatus": {
            "target": UNIQUE_STRING_LIST,
        },
        "spaceType": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_CATALOG_LEAF_RESOURCES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListCatalogLeafResourcesInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "sourceType": {
            "target": STRING,
        },
        "filter": {
            "target": LEAF_RESOURCE_FILTER,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "nextToken": {
            "target": STRING,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

LEAF_RESOURCES_DATA_RECORD_MEMBER = Schema.collection(
    id=ShapeID("borneo#LeafResourcesDataRecordMember"),
    members={
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "parentId": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "compliance": {
            "target": COMPLIANCE_DETAIL_LIST,
        },
        "owner": {
            "target": OWNER_OBJECT_LIST,
        },
        "status": {
            "target": RESOURCE_STATUS,
        },
        "lastScanned": {
            "target": TIMESTAMP,
        },
    },
)

LEAF_RESOURCES_DATA_LIST = Schema.collection(
    id=ShapeID("borneo#LeafResourcesDataList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": LEAF_RESOURCES_DATA_RECORD_MEMBER,
        },
    },
)

LIST_CATALOG_LEAF_RESOURCES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListCatalogLeafResourcesOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "resources": {
            "target": LEAF_RESOURCES_DATA_LIST,
        },
        "count": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

LIST_CATALOG_LEAF_RESOURCES_EXPORT_INPUT = Schema.collection(
    id=ShapeID("borneo#ListCatalogLeafResourcesExportInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "sourceType": {
            "target": STRING,
        },
        "filter": {
            "target": LEAF_RESOURCE_FILTER,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "detailed": {
            "target": BOOLEAN,
        },
    },
)

LIST_CATALOG_LEAF_RESOURCES_EXPORT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListCatalogLeafResourcesExportOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "url": {
            "target": STRING,
        },
    },
)

CONNECTOR_ID = Schema(
    id=ShapeID("borneo#ConnectorId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

CONNECTOR_NAME = Schema(
    id=ShapeID("borneo#ConnectorName"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9.,_ @+=-]{1,100}$"),
    ],
)

CONNECTOR_STATE = Schema.collection(
    id=ShapeID("borneo#ConnectorState"),
    type=ShapeType.ENUM,
    members={
        "DEPLOYEMENT_SUCCESS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="deployment_success"),
            ],
        },
        "DEPLOYEMENT_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="deployment_failed"),
            ],
        },
        "HOSTCONNECTIVITY_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="hostconnectivity_failed"
                ),
            ],
        },
        "CREDENTIALCHECK_FAILED": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="credentialcheck_failed"
                ),
            ],
        },
        "PENDING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="pending"),
            ],
        },
        "AVAILABLE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="available"),
            ],
        },
        "DESTROYING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="destroying"),
            ],
        },
        "DESTROYED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="destroyed"),
            ],
        },
        "UNAVAILABLE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="unavailable"),
            ],
        },
    },
)

CRON_VALUES = Schema.collection(
    id=ShapeID("borneo#CronValues"),
    type=ShapeType.ENUM,
    members={
        "EVERY_30_MIN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="*/30 * * * *"),
            ],
        },
        "EVERY_1_HOUR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 */1 * * *"),
            ],
        },
        "EVERY_4_HOUR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 */4 * * *"),
            ],
        },
        "EVERY_6_HOUR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 */6 * * *"),
            ],
        },
        "EVERY_8_HOUR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 */8 * * *"),
            ],
        },
        "EVERY_12_HOUR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 */12 * * *"),
            ],
        },
        "EVERY_1_DAY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 0 * * *"),
            ],
        },
        "EVERY_1_WEEK": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 0 * * 0"),
            ],
        },
        "EVERY_1_MONTH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 0 1 * *"),
            ],
        },
        "EVERY_6_MONTH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0 0 1 1,7 *"),
            ],
        },
    },
)

DESCRIBE_CONNECTOR_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeConnectorInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "connectorId": {
            "target": CONNECTOR_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_CONNECTOR_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeConnectorOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "connectorId": {
            "target": CONNECTOR_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": CONNECTOR_NAME,
        },
        "state": {
            "target": CONNECTOR_STATE,
        },
        "dataPlaneId": {
            "target": DATA_PLANE_ID,
        },
        "resourceType": {
            "target": STRING,
        },
        "connectorType": {
            "target": STRING,
        },
        "resourceId": {
            "target": RESOURCE_ID,
        },
        "region": {
            "target": STRING,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "params": {
            "target": OPEN_PROPERTIES,
        },
        "resourceAccountId": {
            "target": STRING,
        },
        "nextMetaDataSyncSchedule": {
            "target": TIMESTAMP,
        },
        "isMetaDataSyncRunning": {
            "target": BOOLEAN,
        },
        "metaDataSyncInterval": {
            "target": CRON_VALUES,
        },
    },
)

CONNECTOR_FILTER = Schema.collection(
    id=ShapeID("borneo#ConnectorFilter"),
    members={
        "names": {
            "target": UNIQUE_STRING_LIST,
        },
        "states": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataPlaneIds": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceTypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "connectorTypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceIds": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_CONNECTORS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListConnectorsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": CONNECTOR_FILTER,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "nextToken": {
            "target": STRING,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

CONNECTOR_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#ConnectorListMember"),
    members={
        "connectorId": {
            "target": CONNECTOR_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": CONNECTOR_NAME,
        },
        "state": {
            "target": CONNECTOR_STATE,
        },
        "dataPlaneId": {
            "target": DATA_PLANE_ID,
        },
        "resourceType": {
            "target": STRING,
        },
        "connectorType": {
            "target": STRING,
        },
        "resourceId": {
            "target": RESOURCE_ID,
        },
        "region": {
            "target": STRING,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "params": {
            "target": OPEN_PROPERTIES,
        },
        "resourceAccountId": {
            "target": STRING,
        },
        "nextMetaDataSyncSchedule": {
            "target": TIMESTAMP,
        },
        "isMetaDataSyncRunning": {
            "target": BOOLEAN,
        },
        "metaDataSyncInterval": {
            "target": CRON_VALUES,
        },
    },
)

CONNECTORS_LIST = Schema.collection(
    id=ShapeID("borneo#ConnectorsList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": CONNECTOR_LIST_MEMBER,
        },
    },
)

LIST_CONNECTORS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListConnectorsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "connectors": {
            "target": CONNECTORS_LIST,
        },
        "total": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

DEPARTMENT_MODEL = Schema(
    id=ShapeID("borneo#DepartmentModel"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 1,
                "max": 255,
            },
        ),
    ],
)

CREATE_DEPARTMENT_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateDepartmentInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": DEPARTMENT_MODEL,
        },
    },
)

DEPARTMENT_ID = Schema(
    id=ShapeID("borneo#DepartmentId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

CREATE_DEPARTMENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateDepartmentOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_DEPARTMENT_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDepartmentInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_DEPARTMENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDepartmentOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DEPARTMENT_MODEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DEPARTMENT_SELECT_FILTER = Schema.collection(
    id=ShapeID("borneo#DepartmentSelectFilter"),
    members={
        "search": {
            "target": STRING,
        },
    },
)

LIST_DEPARTMENTS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListDepartmentsInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#DepartmentListInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": DEPARTMENT_SELECT_FILTER,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

DEPARTMENT_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#DepartmentListMember"),
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DEPARTMENT_MODEL,
        },
        "employees": {
            "target": INTEGER,
        },
        "processingActivities": {
            "target": INTEGER,
        },
    },
)

DEPARTMENT_LIST = Schema.collection(
    id=ShapeID("borneo#DepartmentList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DEPARTMENT_LIST_MEMBER,
        },
    },
)

LIST_DEPARTMENTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListDepartmentsOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#DepartmentListOutput",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "departments": {
            "target": DEPARTMENT_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "total": {
            "target": INTEGER,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

LIST_DEPARTMENTS_FOR_FILTER_INPUT = Schema.collection(
    id=ShapeID("borneo#ListDepartmentsForFilterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
)

DEPARTMENT_FOR_FILTER_MEMBER = Schema.collection(
    id=ShapeID("borneo#DepartmentForFilterMember"),
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DEPARTMENT_MODEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DEPARTMENT_FOR_FILTER_LIST = Schema.collection(
    id=ShapeID("borneo#DepartmentForFilterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DEPARTMENT_FOR_FILTER_MEMBER,
        },
    },
)

LIST_DEPARTMENTS_FOR_FILTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListDepartmentsForFilterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "departments": {
            "target": DEPARTMENT_FOR_FILTER_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

REMOVE_DEPARTMENT_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveDepartmentInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_DEPARTMENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveDepartmentOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UPDATE_DEPARTMENT_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateDepartmentInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "name": {
            "target": DEPARTMENT_MODEL,
        },
    },
)

UPDATE_DEPARTMENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateDepartmentOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_DISCOVERED_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDiscoveredRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "discoveredRecipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DISCOVERY_SOURCE_NAME = Schema(
    id=ShapeID("borneo#DiscoverySourceName"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 2000,
            },
        ),
    ],
)

DISCOVERY_SOURCE_LIST = Schema.collection(
    id=ShapeID("borneo#DiscoverySourceList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": DISCOVERY_SOURCE_NAME,
        },
    },
)

DESCRIBE_DISCOVERED_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDiscoveredRecipientOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#DiscoveredRecipientRecord",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "discoveredRecipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "recipientModelId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "discoverySource": {
            "target": DISCOVERY_SOURCE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdAt": {
            "target": TIMESTAMP,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DISCOVERED_RECIPIENT_STATUS = Schema.collection(
    id=ShapeID("borneo#DiscoveredRecipientStatus"),
    type=ShapeType.ENUM,
    members={
        "IGNORED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ignored"),
            ],
        },
        "NEW": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="new"),
            ],
        },
    },
)

DISCOVERED_RECIPIENT_FILTERS = Schema.collection(
    id=ShapeID("borneo#DiscoveredRecipientFilters"),
    members={
        "search": {
            "target": STRING,
        },
        "status": {
            "target": DISCOVERED_RECIPIENT_STATUS,
        },
        "discoverySource": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_DISCOVERED_RECIPIENTS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListDiscoveredRecipientsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "filter": {
            "target": DISCOVERED_RECIPIENT_FILTERS,
        },
    },
)

DISCOVERED_RECIPIENT_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#DiscoveredRecipientListMember"),
    members={
        "discoveredRecipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "recipientModelId": {
            "target": UUID,
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "discoverySource": {
            "target": DISCOVERY_SOURCE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdAt": {
            "target": TIMESTAMP,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "status": {
            "target": DISCOVERED_RECIPIENT_STATUS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "userCount": {
            "target": INTEGER,
        },
    },
)

DISCOVERED_RECIPIENT_LIST = Schema.collection(
    id=ShapeID("borneo#DiscoveredRecipientList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DISCOVERED_RECIPIENT_LIST_MEMBER,
        },
    },
)

LIST_DISCOVERED_RECIPIENTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListDiscoveredRecipientsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "discoveredRecipients": {
            "target": DISCOVERED_RECIPIENT_LIST,
        },
        "nextToken": {
            "target": STRING,
        },
        "total": {
            "target": INTEGER,
        },
    },
)

LIST_DISCOVERED_RECIPIENTS_USERS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListDiscoveredRecipientsUsersInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "discoveredRecipientId": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

OKTA_USER_STATUS = Schema.collection(
    id=ShapeID("borneo#OktaUserStatus"),
    type=ShapeType.ENUM,
    members={
        "ACTIVE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ACTIVE"),
            ],
        },
        "DELETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DELETED"),
            ],
        },
    },
)

USER_ID = Schema(
    id=ShapeID("borneo#UserId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

OKTA_USER_DISCOVERY_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#OktaUserDiscoveryListMember"),
    members={
        "userId": {
            "target": USER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "oktaUsername": {
            "target": STRING,
        },
        "firstName": {
            "target": STRING,
        },
        "lastName": {
            "target": STRING,
        },
        "oktaConnectionId": {
            "target": STRING,
        },
        "oktaEmail": {
            "target": STRING,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "addedToRegister": {
            "target": BOOLEAN,
        },
        "lastDiscoveredAt": {
            "target": TIMESTAMP,
        },
        "status": {
            "target": OKTA_USER_STATUS,
        },
    },
)

OKTA_USER_DISCOVERY_LIST = Schema.collection(
    id=ShapeID("borneo#OktaUserDiscoveryList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": OKTA_USER_DISCOVERY_LIST_MEMBER,
        },
    },
)

LIST_DISCOVERED_RECIPIENTS_USERS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListDiscoveredRecipientsUsersOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "oktaUsers": {
            "target": OKTA_USER_DISCOVERY_LIST,
        },
    },
)

DOMAIN_FREQUENCY = Schema.collection(
    id=ShapeID("borneo#DomainFrequency"),
    type=ShapeType.ENUM,
    members={
        "MANUAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="manual"),
            ],
        },
        "EVERY_6_HOURS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="6h"),
            ],
        },
        "EVERY_12_HOURS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="12h"),
            ],
        },
        "EVERY_1_DAY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="1d"),
            ],
        },
        "EVERY_1_WEEK": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="1w"),
            ],
        },
        "EVERY_30_DAYS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="30d"),
            ],
        },
    },
)

DOMAIN_NAME = Schema(
    id=ShapeID("borneo#DomainName"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 500,
            },
        ),
    ],
)

CREATE_DOMAIN_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateDomainInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": DOMAIN_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "frequency": {
            "target": DOMAIN_FREQUENCY,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

CREATE_DOMAIN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateDomainOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_DOMAIN_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDomainInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

RECIPIENT_NAME = Schema(
    id=ShapeID("borneo#RecipientName"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 255,
            },
        ),
    ],
)

RECIPIENTS_DISCOVERED_OF_DOMAIN_LIST = Schema.collection(
    id=ShapeID("borneo#RecipientsDiscoveredOfDomainList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": RECIPIENT_NAME,
        },
    },
)

DOMAIN_STATUS = Schema.collection(
    id=ShapeID("borneo#DomainStatus"),
    type=ShapeType.ENUM,
    members={
        "DOMAIN_NOT_REACHED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="domain_not_reached"),
            ],
        },
        "IN_PROGRESS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="in_progress"),
            ],
        },
        "COMPLETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="finished"),
            ],
        },
    },
)

DESCRIBE_DOMAIN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDomainOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"), value="borneo#DomainRecord"
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DOMAIN_NAME,
        },
        "status": {
            "target": DOMAIN_STATUS,
        },
        "frequency": {
            "target": DOMAIN_FREQUENCY,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "recipients": {
            "target": RECIPIENTS_DISCOVERED_OF_DOMAIN_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
    },
)

LIST_DOMAINS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListDomainsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

DOMAIN_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#DomainListMember"),
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DOMAIN_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "status": {
            "target": DOMAIN_STATUS,
        },
        "frequency": {
            "target": DOMAIN_FREQUENCY,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdAt": {
            "target": TIMESTAMP,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "recipients": {
            "target": RECIPIENTS_DISCOVERED_OF_DOMAIN_LIST,
        },
    },
)

DOMAIN_LIST = Schema.collection(
    id=ShapeID("borneo#DomainList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DOMAIN_LIST_MEMBER,
        },
    },
)

LIST_DOMAINS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListDomainsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "domains": {
            "target": DOMAIN_LIST,
        },
        "nextToken": {
            "target": STRING,
        },
        "total": {
            "target": INTEGER,
        },
    },
)

POLL_DOMAIN_INPUT = Schema.collection(
    id=ShapeID("borneo#PollDomainInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

POLL_DOMAIN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#PollDomainOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

REMOVE_DOMAIN_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveDomainInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_DOMAIN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveDomainOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_DOMAIN_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateDomainInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "domainId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "name": {
            "target": DOMAIN_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "frequency": {
            "target": DOMAIN_FREQUENCY,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UPDATE_DOMAIN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateDomainOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

DPIA_LONG_TEXT = Schema(
    id=ShapeID("borneo#DpiaLongText"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 4000,
            },
        ),
    ],
)

DPIA_RISK_LIKELIHOOD = Schema.collection(
    id=ShapeID("borneo#DpiaRiskLikelihood"),
    type=ShapeType.ENUM,
    members={
        "NEGLIGIBLE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="negligible"),
            ],
        },
        "UNLIKELY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="unlikely"),
            ],
        },
        "LIMITED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="limited"),
            ],
        },
        "LIKELY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="likely"),
            ],
        },
        "MAXIMUM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="maximum"),
            ],
        },
    },
)

DPIA_RISK_SEVERITY = Schema.collection(
    id=ShapeID("borneo#DpiaRiskSeverity"),
    type=ShapeType.ENUM,
    members={
        "VERY_LOW": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="very_low"),
            ],
        },
        "LOW": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="low"),
            ],
        },
        "MEDIUM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="medium"),
            ],
        },
        "HIGH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="high"),
            ],
        },
        "VERY_HIGH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="very_high"),
            ],
        },
    },
)

DPIA_AVAILABILITY_RISK_IMPACT_ID = Schema(
    id=ShapeID("borneo#DpiaAvailabilityRiskImpactId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|discrimination|financial_loss|damage_reputation|economic|impediment|impediment_prevention|exclusion|physical_harm)$",
        ),
    ],
)

DPIA_CUSTOM_NAME_TEXT = Schema(
    id=ShapeID("borneo#DpiaCustomNameText"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 50,
            },
        ),
    ],
)

DPIA_AVAILABILITY_RISK_IMPACT = Schema.collection(
    id=ShapeID("borneo#DpiaAvailabilityRiskImpact"),
    members={
        "id": {
            "target": DPIA_AVAILABILITY_RISK_IMPACT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_AVAILABILITY_RISK_IMPACTS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaAvailabilityRiskImpactsCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_AVAILABILITY_RISK_IMPACT,
        },
    },
)

DPIA_RISK_RISK_SOURCE_ID = Schema(
    id=ShapeID("borneo#DpiaRiskRiskSourceId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|hardware_error|software_error|employee_error|internal_attack|external_attack|force_majeure|infrastructure_issue)$",
        ),
    ],
)

DPIA_RISK_RISK_SOURCE = Schema.collection(
    id=ShapeID("borneo#DpiaRiskRiskSource"),
    members={
        "id": {
            "target": DPIA_RISK_RISK_SOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_RISK_RISK_SOURCES_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaRiskRiskSourcesCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_RISK_RISK_SOURCE,
        },
    },
)

DPIA_AVAILABILITY_RISK_THREAT_ID = Schema(
    id=ShapeID("borneo#DpiaAvailabilityRiskThreatId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|unauthorized_unlawful|processing|destruction_data|denial_data)$",
        ),
    ],
)

DPIA_AVAILABILITY_RISK_THREAT = Schema.collection(
    id=ShapeID("borneo#DpiaAvailabilityRiskThreat"),
    members={
        "id": {
            "target": DPIA_AVAILABILITY_RISK_THREAT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_AVAILABILITY_RISK_THREATS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaAvailabilityRiskThreatsCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_AVAILABILITY_RISK_THREAT,
        },
    },
)

DPIA_AVAILABILITY_RISK = Schema.collection(
    id=ShapeID("borneo#DpiaAvailabilityRisk"),
    members={
        "threats": {
            "target": DPIA_AVAILABILITY_RISK_THREATS_COLLECTION,
        },
        "threatsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "impacts": {
            "target": DPIA_AVAILABILITY_RISK_IMPACTS_COLLECTION,
        },
        "impactsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "riskSources": {
            "target": DPIA_RISK_RISK_SOURCES_COLLECTION,
        },
        "riskSourcesComment": {
            "target": DPIA_LONG_TEXT,
        },
        "implementedToms": {
            "target": UUID_COLLECTION,
        },
        "implementedTomsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "plannedToms": {
            "target": UUID_COLLECTION,
        },
        "plannedTomsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "baselineSeverity": {
            "target": DPIA_RISK_SEVERITY,
        },
        "baselineLikelihood": {
            "target": DPIA_RISK_LIKELIHOOD,
        },
        "baselineComment": {
            "target": DPIA_LONG_TEXT,
        },
        "residualRiskSeverity": {
            "target": DPIA_RISK_SEVERITY,
        },
        "residualRiskLikelihood": {
            "target": DPIA_RISK_LIKELIHOOD,
        },
        "residualRiskComment": {
            "target": DPIA_LONG_TEXT,
        },
    },
)

DPIA_CONFIDENTIALITY_RISK_IMPACT_ID = Schema(
    id=ShapeID("borneo#DpiaConfidentialityRiskImpactId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|discrimination|identity_theft|financial_loss|damage_reputation|economic|impediment|impediment_prevention|exclusion|profiling|physical_harm)$",
        ),
    ],
)

DPIA_CONFIDENTIALITY_RISK_IMPACT = Schema.collection(
    id=ShapeID("borneo#DpiaConfidentialityRiskImpact"),
    members={
        "id": {
            "target": DPIA_CONFIDENTIALITY_RISK_IMPACT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_CONFIDENTIALITY_RISK_IMPACTS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaConfidentialityRiskImpactsCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_CONFIDENTIALITY_RISK_IMPACT,
        },
    },
)

DPIA_CONFIDENTIALITY_RISK_THREAT_ID = Schema(
    id=ShapeID("borneo#DpiaConfidentialityRiskThreatId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|unauthorized_unlawful|processing|unauthorized_of_data|denial_data|use_data|processing_unanticipated_data|processing_beyond_retention)$",
        ),
    ],
)

DPIA_CONFIDENTIALITY_RISK_THREAT = Schema.collection(
    id=ShapeID("borneo#DpiaConfidentialityRiskThreat"),
    members={
        "id": {
            "target": DPIA_CONFIDENTIALITY_RISK_THREAT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_CONFIDENTIALITY_RISK_THREATS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaConfidentialityRiskThreatsCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_CONFIDENTIALITY_RISK_THREAT,
        },
    },
)

DPIA_CONFIDENTIALITY_RISK = Schema.collection(
    id=ShapeID("borneo#DpiaConfidentialityRisk"),
    members={
        "threats": {
            "target": DPIA_CONFIDENTIALITY_RISK_THREATS_COLLECTION,
        },
        "threatsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "impacts": {
            "target": DPIA_CONFIDENTIALITY_RISK_IMPACTS_COLLECTION,
        },
        "impactsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "riskSources": {
            "target": DPIA_RISK_RISK_SOURCES_COLLECTION,
        },
        "riskSourcesComment": {
            "target": DPIA_LONG_TEXT,
        },
        "implementedToms": {
            "target": UUID_COLLECTION,
        },
        "implementedTomsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "plannedToms": {
            "target": UUID_COLLECTION,
        },
        "plannedTomsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "baselineSeverity": {
            "target": DPIA_RISK_SEVERITY,
        },
        "baselineLikelihood": {
            "target": DPIA_RISK_LIKELIHOOD,
        },
        "baselineComment": {
            "target": DPIA_LONG_TEXT,
        },
        "residualRiskSeverity": {
            "target": DPIA_RISK_SEVERITY,
        },
        "residualRiskLikelihood": {
            "target": DPIA_RISK_LIKELIHOOD,
        },
        "residualRiskComment": {
            "target": DPIA_LONG_TEXT,
        },
    },
)

DPIA_INTEGRITY_RISK_IMPACT_ID = Schema(
    id=ShapeID("borneo#DpiaIntegrityRiskImpactId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|financial_loss|company_standstill|damage_reputation|economic|impediment|impediment_prevention|exclusion|physical_harm)$",
        ),
    ],
)

DPIA_INTEGRITY_RISK_IMPACT = Schema.collection(
    id=ShapeID("borneo#DpiaIntegrityRiskImpact"),
    members={
        "id": {
            "target": DPIA_INTEGRITY_RISK_IMPACT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_INTEGRITY_RISK_IMPACTS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaIntegrityRiskImpactsCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_INTEGRITY_RISK_IMPACT,
        },
    },
)

DPIA_INTEGRITY_RISK_THREAT_ID = Schema(
    id=ShapeID("borneo#DpiaIntegrityRiskThreatId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|unauthorized_unlawful|processing|processing_transparent|denial_data|destruction_data)$",
        ),
    ],
)

DPIA_INTEGRITY_RISK_THREAT = Schema.collection(
    id=ShapeID("borneo#DpiaIntegrityRiskThreat"),
    members={
        "id": {
            "target": DPIA_INTEGRITY_RISK_THREAT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DPIA_CUSTOM_NAME_TEXT,
        },
    },
)

DPIA_INTEGRITY_RISK_THREATS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DpiaIntegrityRiskThreatsCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DPIA_INTEGRITY_RISK_THREAT,
        },
    },
)

DPIA_INTEGRITY_RISK = Schema.collection(
    id=ShapeID("borneo#DpiaIntegrityRisk"),
    members={
        "threats": {
            "target": DPIA_INTEGRITY_RISK_THREATS_COLLECTION,
        },
        "threatsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "impacts": {
            "target": DPIA_INTEGRITY_RISK_IMPACTS_COLLECTION,
        },
        "impactsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "riskSources": {
            "target": DPIA_RISK_RISK_SOURCES_COLLECTION,
        },
        "riskSourcesComment": {
            "target": DPIA_LONG_TEXT,
        },
        "implementedToms": {
            "target": UUID_COLLECTION,
        },
        "implementedTomsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "plannedToms": {
            "target": UUID_COLLECTION,
        },
        "plannedTomsComment": {
            "target": DPIA_LONG_TEXT,
        },
        "baselineSeverity": {
            "target": DPIA_RISK_SEVERITY,
        },
        "baselineLikelihood": {
            "target": DPIA_RISK_LIKELIHOOD,
        },
        "baselineComment": {
            "target": DPIA_LONG_TEXT,
        },
        "residualRiskSeverity": {
            "target": DPIA_RISK_SEVERITY,
        },
        "residualRiskLikelihood": {
            "target": DPIA_RISK_LIKELIHOOD,
        },
        "residualRiskComment": {
            "target": DPIA_LONG_TEXT,
        },
    },
)

DPIA_PRIVACY_FRAMEWORK = Schema.collection(
    id=ShapeID("borneo#DpiaPrivacyFramework"),
    members={
        "purposeLimitation": {
            "target": DPIA_LONG_TEXT,
        },
        "dataMinimisation": {
            "target": DPIA_LONG_TEXT,
        },
        "accuracy": {
            "target": DPIA_LONG_TEXT,
        },
        "retention": {
            "target": BOOLEAN,
        },
        "retentionComment": {
            "target": DPIA_LONG_TEXT,
        },
        "transparency": {
            "target": DPIA_LONG_TEXT,
        },
        "consent": {
            "target": DPIA_LONG_TEXT,
        },
        "dataRightsExercised": {
            "target": DPIA_LONG_TEXT,
        },
        "additionalComment": {
            "target": DPIA_LONG_TEXT,
        },
    },
)

DPIA_STATUS = Schema.collection(
    id=ShapeID("borneo#DpiaStatus"),
    type=ShapeType.ENUM,
    members={
        "DRAFT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="draft"),
            ],
        },
        "ACTIVATED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="activated"),
            ],
        },
    },
)

CREATE_DPIA_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateDpiaInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "processingActivityId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "privacyFramework": {
            "target": DPIA_PRIVACY_FRAMEWORK,
        },
        "confidentiality": {
            "target": DPIA_CONFIDENTIALITY_RISK,
        },
        "integrity": {
            "target": DPIA_INTEGRITY_RISK,
        },
        "availability": {
            "target": DPIA_AVAILABILITY_RISK,
        },
        "additionalInformation": {
            "target": DPIA_LONG_TEXT,
        },
        "additionalInformationFiles": {
            "target": UUID_COLLECTION,
        },
        "status": {
            "target": DPIA_STATUS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

CREATE_DPIA_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateDpiaOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "dpiaId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_DPIA_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDpiaInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "dpiaId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_DPIA_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeDpiaOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "privacyFramework": {
            "target": DPIA_PRIVACY_FRAMEWORK,
        },
        "confidentiality": {
            "target": DPIA_CONFIDENTIALITY_RISK,
        },
        "integrity": {
            "target": DPIA_INTEGRITY_RISK,
        },
        "availability": {
            "target": DPIA_AVAILABILITY_RISK,
        },
        "additionalInformation": {
            "target": DPIA_LONG_TEXT,
        },
        "additionalInformationFiles": {
            "target": UUID_COLLECTION,
        },
        "status": {
            "target": DPIA_STATUS,
        },
    },
)

REMOVE_DPIA_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveDpiaInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "dpiaId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_DPIA_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveDpiaOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_DPIA_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateDpiaInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "dpiaId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "privacyFramework": {
            "target": DPIA_PRIVACY_FRAMEWORK,
        },
        "confidentiality": {
            "target": DPIA_CONFIDENTIALITY_RISK,
        },
        "integrity": {
            "target": DPIA_INTEGRITY_RISK,
        },
        "availability": {
            "target": DPIA_AVAILABILITY_RISK,
        },
        "additionalInformation": {
            "target": DPIA_LONG_TEXT,
        },
        "additionalInformationFiles": {
            "target": UUID_COLLECTION,
        },
        "status": {
            "target": DPIA_STATUS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UPDATE_DPIA_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateDpiaOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

CREATE_EMPLOYEE_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateEmployeeInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "surname": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdBy": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "position": {
            "target": STRING,
        },
        "nif": {
            "target": STRING,
        },
        "startDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "endDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "email": {
            "target": STRING,
        },
        "manager": {
            "target": STRING,
        },
        "department": {
            "target": UUID,
        },
        "referenceId": {
            "target": STRING,
        },
    },
)

EMPLOYEE_ID = Schema(
    id=ShapeID("borneo#EmployeeId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

CREATE_EMPLOYEE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateEmployeeOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DEPARTMENT_OBJECT = Schema.collection(
    id=ShapeID("borneo#DepartmentObject"),
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DEPARTMENT_MODEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_EMPLOYEE_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeEmployeeInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

EMPLOYEE_SELECT_FILTER = Schema.collection(
    id=ShapeID("borneo#EmployeeSelectFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "department": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_EMPLOYEES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListEmployeesInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#EmployeeListInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": EMPLOYEE_SELECT_FILTER,
        },
        "nextToken": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#httpQuery"), value="nextToken"),
            ],
        },
        "pageSize": {
            "target": PAGE_SIZE,
            "traits": [
                Trait(id=ShapeID("smithy.api#httpQuery"), value="pageSize"),
            ],
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

LIST_EMPLOYEES_FOR_FILTER_INPUT = Schema.collection(
    id=ShapeID("borneo#ListEmployeesForFilterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
)

EMPLOYEE_FOR_FILTER_MEMBER = Schema.collection(
    id=ShapeID("borneo#EmployeeForFilterMember"),
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

EMPLOYEES_FOR_FILTER_LIST = Schema.collection(
    id=ShapeID("borneo#EmployeesForFilterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": EMPLOYEE_FOR_FILTER_MEMBER,
        },
    },
)

LIST_EMPLOYEES_FOR_FILTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListEmployeesForFilterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "employees": {
            "target": EMPLOYEES_FOR_FILTER_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

REMOVE_EMPLOYEE_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveEmployeeInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_EMPLOYEE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveEmployeeOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_EMPLOYEE_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateEmployeeInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "surname": {
            "target": STRING,
        },
        "position": {
            "target": STRING,
        },
        "nif": {
            "target": STRING,
        },
        "startDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "endDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "email": {
            "target": STRING,
        },
        "manager": {
            "target": STRING,
        },
        "department": {
            "target": UUID,
        },
    },
)

UPDATE_EMPLOYEE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateEmployeeOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

CREATE_HEADQUARTER_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateHeadquarterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": HEADQUARTER_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "city": {
            "target": HEADQUARTER_CITY,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "address": {
            "target": PHYSICAL_ADDRESS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "country": {
            "target": COUNTRY_CODE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "zipcode": {
            "target": ZIP_CODE,
        },
        "tomIds": {
            "target": UUID_COLLECTION,
        },
    },
)

CREATE_HEADQUARTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateHeadquarterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_HEADQUARTER_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeHeadquarterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_HEADQUARTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeHeadquarterOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#HeadquarterRecord",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": HEADQUARTER_NAME,
        },
        "city": {
            "target": HEADQUARTER_CITY,
        },
        "address": {
            "target": PHYSICAL_ADDRESS,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "zipcode": {
            "target": ZIP_CODE,
        },
        "toms": {
            "target": TOM_COLLECTION,
        },
    },
)

LIST_HEADQUARTERS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListHeadquartersInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#HeadquarterListInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

HEADQUARTER_LIST_RECORD = Schema.collection(
    id=ShapeID("borneo#HeadquarterListRecord"),
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": HEADQUARTER_NAME,
        },
        "city": {
            "target": HEADQUARTER_CITY,
        },
        "address": {
            "target": PHYSICAL_ADDRESS,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "zipcode": {
            "target": ZIP_CODE,
        },
        "toms": {
            "target": TOM_COLLECTION,
        },
    },
)

HEADQUARTER_LIST = Schema.collection(
    id=ShapeID("borneo#HeadquarterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": HEADQUARTER_LIST_RECORD,
        },
    },
)

LIST_HEADQUARTERS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListHeadquartersOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#HeadquarterListOutput",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "headquarters": {
            "target": HEADQUARTER_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "total": {
            "target": INTEGER,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

REMOVE_HEADQUARTER_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveHeadquarterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_HEADQUARTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveHeadquarterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_HEADQUARTER_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateHeadquarterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "headquarterId": {
            "target": HEADQUARTER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "name": {
            "target": HEADQUARTER_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "city": {
            "target": HEADQUARTER_CITY,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "address": {
            "target": PHYSICAL_ADDRESS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "country": {
            "target": COUNTRY_CODE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "zipcode": {
            "target": ZIP_CODE,
        },
        "tomIds": {
            "target": UUID_COLLECTION,
        },
    },
)

UPDATE_HEADQUARTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateHeadquarterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

CATEGORY_LABEL = Schema(
    id=ShapeID("borneo#CategoryLabel"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^.{1,255}$"),
    ],
)

INFOTYPE_CODE = Schema(
    id=ShapeID("borneo#InfotypeCode"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^.{1,255}$"),
    ],
)

INFOTYPE_CODE_LIST = Schema.collection(
    id=ShapeID("borneo#InfotypeCodeList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": INFOTYPE_CODE,
        },
    },
)

CREATE_CATEGORY_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateCategoryInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "description": {
            "target": STRING,
        },
        "infotypes": {
            "target": INFOTYPE_CODE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

CREATE_CATEGORY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateCategoryOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_CATEGORY_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeCategoryInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_CATEGORY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeCategoryOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "description": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

LIST_INFOTYPE_CATEGORIES_FILTER = Schema.collection(
    id=ShapeID("borneo#ListInfotypeCategoriesFilter"),
    members={
        "categories": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_INFOTYPE_CATEGORIES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListInfotypeCategoriesInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": LIST_INFOTYPE_CATEGORIES_FILTER,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

CATEGORY_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#CategoryListMember"),
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "description": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

CATEGORY_LIST = Schema.collection(
    id=ShapeID("borneo#CategoryList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": CATEGORY_LIST_MEMBER,
        },
    },
)

LIST_INFOTYPE_CATEGORIES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListInfotypeCategoriesOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "categories": {
            "target": CATEGORY_LIST,
        },
    },
)

REMOVE_CATEGORY_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveCategoryInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_CATEGORY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveCategoryOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UPDATE_CATEGORY_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateCategoryInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "description": {
            "target": STRING,
        },
        "infotypes": {
            "target": INFOTYPE_CODE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UPDATE_CATEGORY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateCategoryOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "categoryLabel": {
            "target": CATEGORY_LABEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

PREPARE_DETAILED_INSPECTION_RESULT_INPUT = Schema.collection(
    id=ShapeID("borneo#PrepareDetailedInspectionResultInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "scanId": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "pageId": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

PREPARE_DETAILED_INSPECTION_RESULT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#PrepareDetailedInspectionResultOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "url": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
        "success": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
    },
)

INSPECTION_RESULT_ID = Schema(
    id=ShapeID("borneo#InspectionResultId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

INSPECTION_RESULT_TYPE = Schema.collection(
    id=ShapeID("borneo#InspectionResultType"),
    type=ShapeType.ENUM,
    members={
        "SCAN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="scan"),
            ],
        },
        "PAGE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="page"),
            ],
        },
    },
)

DESCRIBE_INSPECTION_RESULT_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeInspectionResultInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "id": {
            "target": INSPECTION_RESULT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "type": {
            "target": INSPECTION_RESULT_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

SCAN_ID = Schema(
    id=ShapeID("borneo#ScanId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

COMPLIANCE_LIST = Schema.collection(
    id=ShapeID("borneo#ComplianceList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": STRING,
        },
    },
)

INFOTYPES_LIST = Schema.collection(
    id=ShapeID("borneo#InfotypesList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": STRING,
        },
    },
)

INSPECTION_POLICY = Schema.collection(
    id=ShapeID("borneo#InspectionPolicy"),
    members={
        "collectTokens": {
            "target": BOOLEAN,
        },
        "maskDetails": {
            "target": BOOLEAN,
        },
        "infotypes": {
            "target": INFOTYPES_LIST,
        },
        "compliance": {
            "target": COMPLIANCE_LIST,
        },
    },
)

TAG_FILTER_ACTION = Schema.collection(
    id=ShapeID("borneo#TagFilterAction"),
    type=ShapeType.ENUM,
    members={
        "INCLUDE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="include"),
            ],
        },
        "EXCLUDE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="exclude"),
            ],
        },
    },
)

TAG_FILTER = Schema.collection(
    id=ShapeID("borneo#TagFilter"),
    members={
        "action": {
            "target": TAG_FILTER_ACTION,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tagKey": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tagValue": {
            "target": STRING,
        },
    },
)

TAG_FILTER_LIST = Schema.collection(
    id=ShapeID("borneo#TagFilterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": TAG_FILTER,
        },
    },
)

UNIQUE_LONG_LIST = Schema.collection(
    id=ShapeID("borneo#UniqueLongList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": LONG,
        },
    },
)

SCAN_RESOURCES = Schema.collection(
    id=ShapeID("borneo#ScanResources"),
    members={
        "accountId": {
            "target": STRING,
        },
        "region": {
            "target": STRING,
        },
        "search": {
            "target": STRING,
        },
        "resourceType": {
            "target": STRING,
        },
        "resourceIds": {
            "target": UNIQUE_STRING_LIST,
        },
        "parentId": {
            "target": STRING,
        },
        "isPublic": {
            "target": BOOLEAN,
        },
        "isUnencrypted": {
            "target": BOOLEAN,
        },
        "tags": {
            "target": TAG_FILTER_LIST,
        },
        "database": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataset": {
            "target": UNIQUE_STRING_LIST,
        },
        "schema": {
            "target": UNIQUE_STRING_LIST,
        },
        "driveId": {
            "target": UNIQUE_STRING_LIST,
        },
        "zendeskGroupId": {
            "target": UNIQUE_LONG_LIST,
        },
        "googleGroups": {
            "target": UNIQUE_STRING_LIST,
        },
        "orgUnitId": {
            "target": UNIQUE_STRING_LIST,
        },
        "driveType": {
            "target": UNIQUE_STRING_LIST,
        },
        "infoTypes": {
            "target": INFO_TYPES_COMBINATION_FILTER,
        },
        "isArchived": {
            "target": BOOLEAN,
        },
        "isExternal": {
            "target": BOOLEAN,
        },
        "teamId": {
            "target": STRING,
        },
        "teamName": {
            "target": STRING,
        },
        "teamUrl": {
            "target": STRING,
        },
        "isPrivate": {
            "target": BOOLEAN,
        },
        "isSlackDirectMessages": {
            "target": BOOLEAN,
        },
        "spaceStatus": {
            "target": UNIQUE_STRING_LIST,
        },
        "spaceType": {
            "target": UNIQUE_STRING_LIST,
        },
        "all": {
            "target": BOOLEAN,
        },
    },
)

SCAN_FILTER_TYPES = Schema.collection(
    id=ShapeID("borneo#ScanFilterTypes"),
    type=ShapeType.ENUM,
    members={
        "LAST_MODIFIED_GREATER_THAN": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="lastModifiedGreaterThan"
                ),
            ],
        },
        "LAST_MODIFIED_LESS_THAN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="lastModifiedLessThan"),
            ],
        },
        "PREFIX": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="prefix"),
            ],
        },
        "FILE_EXTENSIONS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="fileExtensions"),
            ],
        },
        "ONLY_INCLUDE_KEYS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="onlyIncludeKeys"),
            ],
        },
        "VISIBILITY_FILTER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="visibilityFilter"),
            ],
        },
        "INTERNAL_DOMAINS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="internalDomains"),
            ],
        },
        "SCAN_ATTACHMENTS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="scanAttachments"),
            ],
        },
        "ZENDESK_GROUPS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="zendeskGroups"),
            ],
        },
        "JIRA_PROJECTS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="jiraProjects"),
            ],
        },
    },
)

SCAN_FILTER = Schema.collection(
    id=ShapeID("borneo#ScanFilter"),
    members={
        "type": {
            "target": SCAN_FILTER_TYPES,
        },
        "filters": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

SCAN_FILTER_LIST = Schema.collection(
    id=ShapeID("borneo#ScanFilterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": SCAN_FILTER,
        },
    },
)

SCAN_PARAMETERS = Schema.collection(
    id=ShapeID("borneo#ScanParameters"),
    members={
        "resources": {
            "target": SCAN_RESOURCES,
        },
        "resourceType": {
            "target": STRING,
        },
        "scanFilter": {
            "target": SCAN_FILTER_LIST,
        },
        "inspectionPolicy": {
            "target": INSPECTION_POLICY,
        },
    },
)

RECORD_TYPE = Schema.collection(
    id=ShapeID("borneo#RecordType"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": STRING,
        },
    },
)

INSIGHT_STATUS = Schema.collection(
    id=ShapeID("borneo#InsightStatus"),
    type=ShapeType.ENUM,
    members={
        "PROCESSED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="processed"),
            ],
        },
        "FAILED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="failed"),
            ],
        },
    },
)

DESCRIBE_INSPECTION_RESULT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeInspectionResultOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#InspectionResultRecord",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "id": {
            "target": INSPECTION_RESULT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "scanId": {
            "target": SCAN_ID,
        },
        "scanIterationId": {
            "target": STRING,
        },
        "resourceId": {
            "target": RESOURCE_ID,
        },
        "resourceName": {
            "target": STRING,
        },
        "resourceType": {
            "target": STRING,
        },
        "fileName": {
            "target": STRING,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "compliance": {
            "target": COMPLIANCE_DETAIL_LIST,
        },
        "parentId": {
            "target": STRING,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "stats": {
            "target": RECORD_TYPE,
        },
        "tokens": {
            "target": TOKENS,
        },
        "sampleTokens": {
            "target": TOKENS,
        },
        "scanParameters": {
            "target": SCAN_PARAMETERS,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "hasFinding": {
            "target": BOOLEAN,
        },
        "status": {
            "target": INSIGHT_STATUS,
        },
        "userName": {
            "target": STRING,
        },
        "userEmail": {
            "target": STRING,
        },
    },
)

INSIGHT_STATUS_LIST = Schema.collection(
    id=ShapeID("borneo#InsightStatusList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": INSIGHT_STATUS,
        },
    },
)

INSPECTION_RESULT_FILTER = Schema.collection(
    id=ShapeID("borneo#InspectionResultFilter"),
    members={
        "scanId": {
            "target": STRING,
        },
        "pageId": {
            "target": STRING,
        },
        "resourceIds": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceType": {
            "target": STRING,
        },
        "scanIterationId": {
            "target": STRING,
        },
        "infoTypes": {
            "target": INFO_TYPES_COMBINATION_FILTER,
        },
        "userEmails": {
            "target": UNIQUE_STRING_LIST,
        },
        "status": {
            "target": INSIGHT_STATUS_LIST,
        },
    },
)

LIST_INSPECTION_RESULTS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListInspectionResultsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "type": {
            "target": INSPECTION_RESULT_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "filter": {
            "target": INSPECTION_RESULT_FILTER,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

INSPECTION_RESULT_RECORD = Schema.collection(
    id=ShapeID("borneo#InspectionResultRecord"),
    members={
        "id": {
            "target": INSPECTION_RESULT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "scanId": {
            "target": SCAN_ID,
        },
        "scanIterationId": {
            "target": STRING,
        },
        "resourceId": {
            "target": RESOURCE_ID,
        },
        "resourceName": {
            "target": STRING,
        },
        "resourceType": {
            "target": STRING,
        },
        "fileName": {
            "target": STRING,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "compliance": {
            "target": COMPLIANCE_DETAIL_LIST,
        },
        "parentId": {
            "target": STRING,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "stats": {
            "target": RECORD_TYPE,
        },
        "tokens": {
            "target": TOKENS,
        },
        "sampleTokens": {
            "target": TOKENS,
        },
        "scanParameters": {
            "target": SCAN_PARAMETERS,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "hasFinding": {
            "target": BOOLEAN,
        },
        "status": {
            "target": INSIGHT_STATUS,
        },
        "userName": {
            "target": STRING,
        },
        "userEmail": {
            "target": STRING,
        },
    },
)

INSPECTION_RESULT_LIST = Schema.collection(
    id=ShapeID("borneo#InspectionResultList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": INSPECTION_RESULT_RECORD,
        },
    },
)

LIST_INSPECTION_RESULTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListInspectionResultsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "inspectionResults": {
            "target": INSPECTION_RESULT_LIST,
        },
        "count": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

PAGE_INSIGHTS_EXPORT_INPUT = Schema.collection(
    id=ShapeID("borneo#PageInsightsExportInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "filter": {
            "target": INSPECTION_RESULT_FILTER,
        },
    },
)

PAGE_INSIGHTS_EXPORT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#PageInsightsExportOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "url": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
    },
)

COMPLIANCE_RISK = Schema.collection(
    id=ShapeID("borneo#ComplianceRisk"),
    members={
        "infotypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "classifications": {
            "target": UNIQUE_STRING_LIST,
        },
        "sensitive": {
            "target": BOOLEAN,
        },
    },
)

DATA_SECURITY_EVENT = Schema.collection(
    id=ShapeID("borneo#DataSecurityEvent"),
    members={
        "eventId": {
            "target": STRING,
        },
        "issueId": {
            "target": STRING,
        },
        "resourceId": {
            "target": STRING,
        },
        "source": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "details": {
            "target": OPEN_PROPERTIES,
        },
    },
)

DATA_SECURITY_EVENT_LIST = Schema.collection(
    id=ShapeID("borneo#DataSecurityEventList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DATA_SECURITY_EVENT,
        },
    },
)

ISSUE_ID = Schema(
    id=ShapeID("borneo#IssueId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

DESCRIBE_ISSUE_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeIssueInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "issueId": {
            "target": ISSUE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

ISSUE_NOTIFICATION = Schema.collection(
    id=ShapeID("borneo#IssueNotification"),
    members={
        "success": {
            "target": BOOLEAN,
        },
        "type": {
            "target": STRING,
        },
        "link": {
            "target": STRING,
        },
        "time": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
    },
)

ISSUE_NOTIFICATION_LIST = Schema.collection(
    id=ShapeID("borneo#IssueNotificationList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": ISSUE_NOTIFICATION,
        },
    },
)

ISSUE_RESOURCE_DETAILS = Schema.collection(
    id=ShapeID("borneo#IssueResourceDetails"),
    members={
        "name": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "compliance": {
            "target": COMPLIANCE_DETAIL_LIST,
        },
        "owner": {
            "target": OWNER_OBJECT_LIST,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "status": {
            "target": RESOURCE_STATUS,
        },
        "aka": {
            "target": STRING,
        },
        "properties": {
            "target": OPEN_PROPERTIES,
        },
    },
)

SECURITY_RISK = Schema.collection(
    id=ShapeID("borneo#SecurityRisk"),
    members={
        "failedRules": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

SEVERITY_LEVEL = Schema.collection(
    id=ShapeID("borneo#SeverityLevel"),
    type=ShapeType.ENUM,
    members={
        "INFORMATIONAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="INFORMATIONAL"),
            ],
        },
        "LOW": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="LOW"),
            ],
        },
        "MEDIUM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MEDIUM"),
            ],
        },
        "HIGH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="HIGH"),
            ],
        },
        "CRITICAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="CRITICAL"),
            ],
        },
    },
)

ISSUE_STATE = Schema.collection(
    id=ShapeID("borneo#IssueState"),
    type=ShapeType.ENUM,
    members={
        "OPEN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="open"),
            ],
        },
        "RESOLVED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="resolved"),
            ],
        },
    },
)

DESCRIBE_ISSUE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeIssueOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"), value="borneo#IssueRecord"
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "issueId": {
            "target": ISSUE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "resourceId": {
            "target": STRING,
        },
        "state": {
            "target": ISSUE_STATE,
        },
        "severity": {
            "target": SEVERITY_LEVEL,
        },
        "resource": {
            "target": ISSUE_RESOURCE_DETAILS,
        },
        "securityRisk": {
            "target": SECURITY_RISK,
        },
        "complianceRisk": {
            "target": COMPLIANCE_RISK,
        },
        "events": {
            "target": DATA_SECURITY_EVENT_LIST,
        },
        "notifications": {
            "target": ISSUE_NOTIFICATION_LIST,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

EVENTS_FILTER = Schema.collection(
    id=ShapeID("borneo#EventsFilter"),
    members={
        "eventId": {
            "target": UNIQUE_STRING_LIST,
        },
        "issueId": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceId": {
            "target": UNIQUE_STRING_LIST,
        },
        "scanId": {
            "target": UNIQUE_STRING_LIST,
        },
        "userId": {
            "target": UNIQUE_STRING_LIST,
        },
        "search": {
            "target": STRING,
        },
        "issueType": {
            "target": UNIQUE_STRING_LIST,
        },
        "newInfotypeFound": {
            "target": BOOLEAN,
        },
    },
)

LIST_EVENTS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListEventsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": EVENTS_FILTER,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "select": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

EVENTS = Schema.collection(
    id=ShapeID("borneo#Events"),
    members={
        "eventId": {
            "target": STRING,
        },
        "issueId": {
            "target": STRING,
        },
        "resourceId": {
            "target": STRING,
        },
        "source": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "details": {
            "target": DOCUMENT,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "resourceName": {
            "target": STRING,
        },
        "scanId": {
            "target": STRING,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "tokens": {
            "target": TOKENS,
        },
        "status": {
            "target": STRING,
        },
        "scanIterationId": {
            "target": STRING,
        },
        "scanExecutionId": {
            "target": STRING,
        },
        "meta": {
            "target": DOCUMENT,
        },
        "pageInspectionInsightId": {
            "target": STRING,
        },
        "resourceType": {
            "target": STRING,
        },
        "userId": {
            "target": STRING,
        },
        "name": {
            "target": STRING,
        },
        "email": {
            "target": STRING,
        },
        "connectorUserId": {
            "target": STRING,
        },
        "connectorUsername": {
            "target": STRING,
        },
        "external": {
            "target": BOOLEAN,
        },
    },
)

EVENTS_LIST = Schema.collection(
    id=ShapeID("borneo#EventsList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": EVENTS,
        },
    },
)

LIST_EVENTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListEventsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "total": {
            "target": INTEGER,
        },
        "events": {
            "target": EVENTS_LIST,
        },
    },
)

ISSUE_FILTER = Schema.collection(
    id=ShapeID("borneo#IssueFilter"),
    members={
        "resources": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceTypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "cloudAccountTypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "cloudAccountIds": {
            "target": UNIQUE_STRING_LIST,
        },
        "states": {
            "target": UNIQUE_STRING_LIST,
        },
        "severities": {
            "target": UNIQUE_STRING_LIST,
        },
        "search": {
            "target": STRING,
        },
        "failedControls": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

RELATION_EXPRESSION = Schema.collection(
    id=ShapeID("borneo#RelationExpression"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": BOOLEAN,
        },
    },
)

LIST_ISSUES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListIssuesInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": ISSUE_FILTER,
        },
        "select": {
            "target": UNIQUE_STRING_LIST,
        },
        "include": {
            "target": RELATION_EXPRESSION,
        },
        "nextToken": {
            "target": STRING,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "pageSize": {
            "target": PAGE_SIZE,
            "traits": [
                Trait(id=ShapeID("smithy.api#default"), value=10),
            ],
        },
    },
)

ISSUE_RECORD = Schema.collection(
    id=ShapeID("borneo#IssueRecord"),
    members={
        "issueId": {
            "target": ISSUE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "resourceId": {
            "target": STRING,
        },
        "state": {
            "target": ISSUE_STATE,
        },
        "severity": {
            "target": SEVERITY_LEVEL,
        },
        "resource": {
            "target": ISSUE_RESOURCE_DETAILS,
        },
        "securityRisk": {
            "target": SECURITY_RISK,
        },
        "complianceRisk": {
            "target": COMPLIANCE_RISK,
        },
        "events": {
            "target": DATA_SECURITY_EVENT_LIST,
        },
        "notifications": {
            "target": ISSUE_NOTIFICATION_LIST,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

ISSUE_LIST = Schema.collection(
    id=ShapeID("borneo#IssueList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": ISSUE_RECORD,
        },
    },
)

LIST_ISSUES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListIssuesOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "issues": {
            "target": ISSUE_LIST,
        },
        "total": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

LOG_TYPE = Schema.collection(
    id=ShapeID("borneo#LogType"),
    type=ShapeType.ENUM,
    members={
        "API": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="API"),
            ],
        },
    },
)

LIST_LOGS_FILTER = Schema.collection(
    id=ShapeID("borneo#ListLogsFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "logType": {
            "target": LOG_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#default"), value="API"),
            ],
        },
        "email": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#pattern"),
                    value="^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\\.[a-zA-Z]{2,}$",
                ),
            ],
        },
        "operationName": {
            "target": STRING,
        },
        "requestId": {
            "target": STRING,
        },
        "start": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#length"),
                    value={
                        "min": 19,
                        "max": 19,
                    },
                ),
            ],
        },
        "end": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#length"),
                    value={
                        "min": 19,
                        "max": 19,
                    },
                ),
            ],
        },
    },
)

LIST_LOGS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListLogsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": LIST_LOGS_FILTER,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

LOG_MEMBER = Schema.collection(
    id=ShapeID("borneo#LogMember"),
    members={
        "time": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "email": {
            "target": STRING,
        },
        "requestId": {
            "target": STRING,
        },
        "roles": {
            "target": UNIQUE_STRING_LIST,
        },
        "operation": {
            "target": STRING,
        },
        "msg": {
            "target": STRING,
        },
    },
)

LOGS_RESULTS = Schema.collection(
    id=ShapeID("borneo#LogsResults"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": LOG_MEMBER,
        },
    },
)

LIST_LOGS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListLogsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "logs": {
            "target": LOGS_RESULTS,
        },
        "size": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

MIGRATION_ID = Schema(
    id=ShapeID("borneo#MigrationId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

COMPANY_ROLE = Schema.collection(
    id=ShapeID("borneo#CompanyRole"),
    type=ShapeType.ENUM,
    members={
        "CONTROLLER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="controller"),
            ],
        },
        "PROCESSOR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="processor"),
            ],
        },
        "JOINT_CONTROLLER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="joint_controller"),
            ],
        },
        "SUB_PROCESSOR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="sub_processor"),
            ],
        },
    },
)

PRIVACY_OPS_LONG_TEXT = Schema(
    id=ShapeID("borneo#PrivacyOpsLongText"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 2000,
            },
        ),
    ],
)

PROCESSING_ACTIVITY_DATA_SOURCE = Schema(
    id=ShapeID("borneo#ProcessingActivityDataSource"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|data_controller|data_processor|data_subject|legal_representative|other_processing_activity|public_source|self_generated|third_party)$",
        ),
    ],
)

PROCESSING_ACTIVITIY_DATA_SOURCE_COLLECTION = Schema.collection(
    id=ShapeID("borneo#ProcessingActivitiyDataSourceCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": PROCESSING_ACTIVITY_DATA_SOURCE,
        },
    },
)

DATA_SUBJECT = Schema(
    id=ShapeID("borneo#DataSubject"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|candidates|citizens|clients|contributors|employees|potential_clients|suppliers|users|visitors)$",
        ),
    ],
)

DATA_SUBJECT_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DataSubjectCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": DATA_SUBJECT,
        },
    },
)

DATA_TYPE_ID = Schema(
    id=ShapeID("borneo#DataTypeId"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|address|age|bank_account|behavioural_data|curriculum_vitae|date_of_birth|email|gender|id_number|ip_address|name_and_last_name|nationality|phone_number|salary|social_security_number|training_data|username)$",
        ),
    ],
)

DATA_TYPE = Schema.collection(
    id=ShapeID("borneo#DataType"),
    members={
        "id": {
            "target": DATA_TYPE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DATA_TYPE_COLLECTION = Schema.collection(
    id=ShapeID("borneo#DataTypeCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": DATA_TYPE,
        },
    },
)

INFOTYPE_CATEGORY_LIST = Schema.collection(
    id=ShapeID("borneo#InfotypeCategoryList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": STRING,
        },
    },
)

INFOTYPE_VOLUME = Schema.collection(
    id=ShapeID("borneo#InfotypeVolume"),
    type=ShapeType.ENUM,
    members={
        "VOLUME_0_1000": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="0-1000"),
            ],
        },
        "VOLUME_1000_10000": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="1000-10000"),
            ],
        },
        "VOLUME_10000_100000": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="10000-100000"),
            ],
        },
        "VOLUME_100000_PLUS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="100000+"),
            ],
        },
    },
)

LANGUAGE_TYPE = Schema.collection(
    id=ShapeID("borneo#LanguageType"),
    type=ShapeType.ENUM,
    members={
        "ES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="es"),
            ],
        },
        "EN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="en"),
            ],
        },
        "DE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="de"),
            ],
        },
    },
)

LAWFULNESS_TYPE = Schema.collection(
    id=ShapeID("borneo#LawfulnessType"),
    type=ShapeType.ENUM,
    members={
        "CONSENT_PERSON_CONCERNED": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="consent_person_concerned"
                ),
            ],
        },
        "CONTRACT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="contract"),
            ],
        },
        "STAKEHOLDER_VITAL_INTEREST": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"),
                    value="stakeholder_vital_interest",
                ),
            ],
        },
        "LEGITIMATE_INTEREST": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="legitimate_interest"),
            ],
        },
        "PUBLIC_INTEREST": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="public_interest"),
            ],
        },
        "LEGAL_OBLIGATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="legal_obligation"),
            ],
        },
    },
)

LAWFUL_BASIS = Schema.collection(
    id=ShapeID("borneo#LawfulBasis"),
    members={
        "lawfulnessType": {
            "target": LAWFULNESS_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "comment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
    },
)

LAWFUL_BASIS_COLLECTION = Schema.collection(
    id=ShapeID("borneo#LawfulBasisCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": LAWFUL_BASIS,
        },
    },
)

MANAGEMENT_METHOD_TYPE = Schema.collection(
    id=ShapeID("borneo#ManagementMethodType"),
    type=ShapeType.ENUM,
    members={
        "EMAIL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="email"),
            ],
        },
        "POSTAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="postal"),
            ],
        },
    },
)

POSTAL_ADDRESS = Schema.collection(
    id=ShapeID("borneo#PostalAddress"),
    members={
        "street": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "city": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "country": {
            "target": COUNTRY_CODE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "zipcode": {
            "target": ZIP_CODE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

MANAGEMENT_METHOD = Schema.collection(
    id=ShapeID("borneo#ManagementMethod"),
    members={
        "methodType": {
            "target": MANAGEMENT_METHOD_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "email": {
            "target": STRING,
        },
        "postalAddress": {
            "target": POSTAL_ADDRESS,
        },
    },
)

MANAGEMENT_METHOD_COLLECTION = Schema.collection(
    id=ShapeID("borneo#ManagementMethodCollection"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": MANAGEMENT_METHOD,
        },
    },
)

PRIVACY_OPS_STANDARD_TEXT = Schema(
    id=ShapeID("borneo#PrivacyOpsStandardText"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 300,
            },
        ),
    ],
)

DATA_PROCESSING_FREQUENCY = Schema.collection(
    id=ShapeID("borneo#DataProcessingFrequency"),
    type=ShapeType.ENUM,
    members={
        "IS_SYSTEMATIC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="is_systematic"),
            ],
        },
        "IS_NOT_SYSTEMATIC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="not_systematic"),
            ],
        },
    },
)

RECIPIENT_ROLE = Schema.collection(
    id=ShapeID("borneo#RecipientRole"),
    type=ShapeType.ENUM,
    members={
        "CONTROLLER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="controller"),
            ],
        },
        "PROCESSOR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="processor"),
            ],
        },
        "JOINT_CONTROLLER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="joint_controller"),
            ],
        },
        "SUB_PROCESSOR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="sub_processor"),
            ],
        },
    },
)

PROCESSING_ACTIVITY_RECIPIENT = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityRecipient"),
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "role": {
            "target": RECIPIENT_ROLE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "comment": {
            "target": STRING,
        },
    },
)

RECIPIENT_COLLECTION = Schema.collection(
    id=ShapeID("borneo#RecipientCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 1,
            },
        ),
    ],
    members={
        "member": {
            "target": PROCESSING_ACTIVITY_RECIPIENT,
        },
    },
)

RETENTION_PERIOD_UNIT = Schema.collection(
    id=ShapeID("borneo#RetentionPeriodUnit"),
    type=ShapeType.ENUM,
    members={
        "DAY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="day"),
            ],
        },
        "WEEK": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="week"),
            ],
        },
        "MONTH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="month"),
            ],
        },
        "YEAR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="year"),
            ],
        },
    },
)

RETENTION_PERIOD = Schema.collection(
    id=ShapeID("borneo#RetentionPeriod"),
    members={
        "unit": {
            "target": RETENTION_PERIOD_UNIT,
        },
        "value": {
            "target": INTEGER,
        },
    },
)

CREATE_PROCESSING_ACTIVITY_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateProcessingActivityInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "active": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "additionalInfo": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "additionalInfoFiles": {
            "target": UUID_COLLECTION,
        },
        "assets": {
            "target": UUID_COLLECTION,
        },
        "companyRole": {
            "target": COMPANY_ROLE,
        },
        "contactPerson": {
            "target": UUID,
        },
        "dataSources": {
            "target": PROCESSING_ACTIVITIY_DATA_SOURCE_COLLECTION,
        },
        "dataSubjects": {
            "target": DATA_SUBJECT_COLLECTION,
        },
        "dataTypes": {
            "target": DATA_TYPE_COLLECTION,
        },
        "departments": {
            "target": UUID_COLLECTION,
        },
        "lawfulBasis": {
            "target": LAWFUL_BASIS_COLLECTION,
        },
        "modelId": {
            "target": UUID,
        },
        "name": {
            "target": PRIVACY_OPS_STANDARD_TEXT,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(
                    id=ShapeID("smithy.api#length"),
                    value={
                        "min": 3,
                        "max": 300,
                    },
                ),
            ],
        },
        "purpose": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "recipients": {
            "target": RECIPIENT_COLLECTION,
        },
        "retentionPeriod": {
            "target": RETENTION_PERIOD,
        },
        "retentionPeriodComment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "infotypes": {
            "target": INFOTYPES_LIST,
        },
        "infotypeCategories": {
            "target": INFOTYPE_CATEGORY_LIST,
        },
        "infotypeVolume": {
            "target": INFOTYPE_VOLUME,
        },
        "processingFrequency": {
            "target": DATA_PROCESSING_FREQUENCY,
        },
        "processingFrequencyComment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "isDataStored": {
            "target": BOOLEAN,
        },
        "areAccessRequestsManaged": {
            "target": BOOLEAN,
        },
        "managementMethods": {
            "target": MANAGEMENT_METHOD_COLLECTION,
        },
        "language": {
            "target": LANGUAGE_TYPE,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

PROCESSING_ACTIVITY_ID = Schema(
    id=ShapeID("borneo#ProcessingActivityId"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9-._]{1,36}$"),
    ],
)

CREATE_PROCESSING_ACTIVITY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateProcessingActivityOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "processingActivityId": {
            "target": PROCESSING_ACTIVITY_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_PROCESSING_ACTIVITY_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeProcessingActivityInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "processingActivityId": {
            "target": PROCESSING_ACTIVITY_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

PROCESSING_ACTIVITY_ASSET_LIST = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityAssetList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": ASSET_RECORD,
        },
    },
)

PROCESSING_ACTIVITY_EMPLOYEE = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityEmployee"),
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "surname": {
            "target": STRING,
        },
    },
)

PROCESSING_ACTIVITY_DEPARTMENT = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityDepartment"),
    members={
        "departmentId": {
            "target": DEPARTMENT_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": DEPARTMENT_MODEL,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

PROCESSING_ACTIVITY_DEPARTMENT_LIST = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityDepartmentList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": PROCESSING_ACTIVITY_DEPARTMENT,
        },
    },
)

RECIPIENT_BUSINESS_NAME = Schema(
    id=ShapeID("borneo#RecipientBusinessName"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 200,
            },
        ),
    ],
)

RECIPIENT_CATEGORY = Schema.collection(
    id=ShapeID("borneo#RecipientCategory"),
    type=ShapeType.ENUM,
    members={
        "ACCOUNTING_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="accountingSoftware"),
            ],
        },
        "ADMIN_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="adminDepartment"),
            ],
        },
        "CLOUD_COMPUTING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cloudComputing"),
            ],
        },
        "CLOUD_STORAGE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cloudStorage"),
            ],
        },
        "CRM_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="crmSoftware"),
            ],
        },
        "CUSTOMER_SERVICE_PROVIDER": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="customerServiceProvider"
                ),
            ],
        },
        "CUSTOMER_SUPPORT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="customerSupport"),
            ],
        },
        "DATA_STORAGE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dataStorage"),
            ],
        },
        "ECOMMERCE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="eCommerce"),
            ],
        },
        "EMAIL_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="emailServices"),
            ],
        },
        "ERP_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="erpSoftware"),
            ],
        },
        "EVENTS_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="eventsSoftware"),
            ],
        },
        "HOSTING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="hosting"),
            ],
        },
        "INTERNAL_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="internalDepartment"),
            ],
        },
        "IT_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="itDepartment"),
            ],
        },
        "LAW_ENFORCEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="lawEnforcement"),
            ],
        },
        "LAW_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="lawServices"),
            ],
        },
        "LEGAL_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="legalDepartment"),
            ],
        },
        "LOGISTICS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="logistics"),
            ],
        },
        "MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="management"),
            ],
        },
        "MARKETING_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="marketingDepartment"),
            ],
        },
        "MARKETING_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="marketingSoftware"),
            ],
        },
        "MARKETING_TOOLS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="marketingTools"),
            ],
        },
        "MESSAGING_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="messagingServices"),
            ],
        },
        "OFFICES_APPS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="officesApps"),
            ],
        },
        "ORDERING_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="orderingSoftware"),
            ],
        },
        "OTHER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="other"),
            ],
        },
        "PASSWORD_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="passwordManagement"),
            ],
        },
        "PAYMENT_PLATFORM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="paymentPlatform"),
            ],
        },
        "PRDEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="prDepartment"),
            ],
        },
        "PREVENTION_RISKS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="preventionRisks"),
            ],
        },
        "PRODUCTION_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="productionDepartment"),
            ],
        },
        "PROPERTY_ADMINISTRATION": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="propertyAdministration"
                ),
            ],
        },
        "PUBLICA_DMINISTRATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="publicAdministration"),
            ],
        },
        "RRHH_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="rrhhDepartment"),
            ],
        },
        "RRHH_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="rrhhManagement"),
            ],
        },
        "RRHH_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="rrhhSoftware"),
            ],
        },
        "SECURITY_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="securityServices"),
            ],
        },
        "SELL_DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="sellDepartment"),
            ],
        },
        "SERVICES_PLATFORM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="servicesPlatform"),
            ],
        },
        "TAX_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="taxManagement"),
            ],
        },
        "TIC_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ticServices"),
            ],
        },
        "TRACKING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="tracking"),
            ],
        },
        "CORE_BANKING_SYSTEM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="coreBankingSystem"),
            ],
        },
        "REGULATORY_REPORTING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="regulatoryReporting"),
            ],
        },
        "BANKCARDS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="bankCards"),
            ],
        },
        "IT_INFRASTRUCTURE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ITInfrastructure"),
            ],
        },
        "OFFICE_APPLICATIONS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="officeApplications"),
            ],
        },
        "PHYSICAL_SECURITY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="physicalSecurity"),
            ],
        },
        "CYBER_SECURITY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cyberSecurity"),
            ],
        },
        "FINANCIAL_CRIME": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="financialCrime"),
            ],
        },
        "PHYSICAL_STORAGE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="physicalStorage"),
            ],
        },
        "MOBILITY_EQUIPMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="mobilityEquipment"),
            ],
        },
        "AUDIT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="audit"),
            ],
        },
        "INFORMATION_TECHNOLOGY": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="informationTechnology"
                ),
            ],
        },
        "SAAS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="saas"),
            ],
        },
        "ENTERPRISE_SOFTWARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="enterpriseSoftware"),
            ],
        },
        "FINANCIAL_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="financialServices"),
            ],
        },
        "ANALYTICS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="analytics"),
            ],
        },
        "SECURITY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="security"),
            ],
        },
        "ADVERTISING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="advertising"),
            ],
        },
        "CONSULTING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="consulting"),
            ],
        },
        "HEALTH_CARE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="healthCare"),
            ],
        },
        "ARTIFICIAL_INTELLIGENCE_AI": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="artificialIntelligenceAi"
                ),
            ],
        },
        "APPS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="apps"),
            ],
        },
        "EDUCATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="education"),
            ],
        },
        "FINTECH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="fintech"),
            ],
        },
        "NETWORK_SECURITY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="networkSecurity"),
            ],
        },
        "SOCIAL_MEDIA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="socialMedia"),
            ],
        },
        "MOBILE_APPS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="mobileApps"),
            ],
        },
        "TELECOMMUNICATIONS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="telecommunications"),
            ],
        },
        "INSURANCE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="insurance"),
            ],
        },
        "BIG_DATA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="bigData"),
            ],
        },
        "DEVELOPER_TOOLS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="developerTools"),
            ],
        },
        "BUSINESS_INTELLIGENCE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="businessIntelligence"),
            ],
        },
        "B2B": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="b2b"),
            ],
        },
        "MACHINE_LEARNING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="machineLearning"),
            ],
        },
        "CLOUD_SECURITY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cloudSecurity"),
            ],
        },
        "TRAINING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="training"),
            ],
        },
        "CLOUD_DATA_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cloudDataServices"),
            ],
        },
        "RETAIL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="retail"),
            ],
        },
        "PROJECT_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="projectManagement"),
            ],
        },
        "PROFESSIONAL_SERVICES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="professionalServices"),
            ],
        },
        "TRAVEL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="travel"),
            ],
        },
        "PUBLISHING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="publishing"),
            ],
        },
        "ELEARNING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="e-learning"),
            ],
        },
        "REAL_ESTATE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="realEstate"),
            ],
        },
        "BUSINESS_DEVELOPMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="businessDevelopment"),
            ],
        },
        "RISK_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="riskManagement"),
            ],
        },
        "VIDEO": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="video"),
            ],
        },
        "NON_PROFIT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="nonProfit"),
            ],
        },
        "TRANSPORTATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="transportation"),
            ],
        },
        "CONTENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="content"),
            ],
        },
        "COMPLIANCE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="compliance"),
            ],
        },
        "MARKETING_AUTOMATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="marketingAutomation"),
            ],
        },
        "DIGITAL_MEDIA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="digitalMedia"),
            ],
        },
        "CLOUD_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cloudManagement"),
            ],
        },
        "DATA_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dataManagement"),
            ],
        },
        "PRODUCTIVITY_TOOLS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="productivityTools"),
            ],
        },
        "SMALL_AND_MEDIUM_BUSINESSES": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="smallAndMediumBusinesses"
                ),
            ],
        },
        "EVENTS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="events"),
            ],
        },
        "MEDICAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="medical"),
            ],
        },
        "AUTOMOTIVE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="automotive"),
            ],
        },
        "IDENTITY_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="identityManagement"),
            ],
        },
        "WEB_DESIGN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="webDesign"),
            ],
        },
        "DOCUMENT_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="documentManagement"),
            ],
        },
        "DEVOPS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="devops"),
            ],
        },
        "SEARCH_ENGINE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="searchEngine"),
            ],
        },
        "COMMUNITIES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="communities"),
            ],
        },
        "EDTECH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="edtech"),
            ],
        },
        "MARKETPLACE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="marketplace"),
            ],
        },
        "WELLNESS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="wellness"),
            ],
        },
        "MARKET_RESEARCH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="marketResearch"),
            ],
        },
        "DATA_INTEGRATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dataIntegration"),
            ],
        },
        "ONLINE_PORTALS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="onlinePortals"),
            ],
        },
        "HOSPITALITY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="hospitality"),
            ],
        },
        "DATABASE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="database"),
            ],
        },
        "OUTSOURCING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="outsourcing"),
            ],
        },
        "ASSET_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="assetManagement"),
            ],
        },
        "ELECTRONICS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="electronics"),
            ],
        },
        "INTERNET_OF_THINGS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="internetOfThings"),
            ],
        },
        "EMAIL_MARKETING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="emailMarketing"),
            ],
        },
        "DATA_VISUALIZATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dataVisualization"),
            ],
        },
        "VENTURE_CAPITAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ventureCapital"),
            ],
        },
        "CONSUMER_ELECTRONICS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="consumerElectronics"),
            ],
        },
        "ENTERPRISE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="enterprise"),
            ],
        },
        "ENERGY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="energy"),
            ],
        },
        "CONSTRUCTION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="construction"),
            ],
        },
        "INSURTECH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="insurtech"),
            ],
        },
        "FILE_SHARING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="fileSharing"),
            ],
        },
        "TOURISM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="tourism"),
            ],
        },
        "VIDEO_STREAMING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="videoStreaming"),
            ],
        },
        "FOOD_AND_BEVERAGE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="foodAndBeverage"),
            ],
        },
        "VOIP": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="voip"),
            ],
        },
        "SUPPLY_CHAIN_MANAGEMENT": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="supplyChainManagement"
                ),
            ],
        },
        "FITNESS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="fitness"),
            ],
        },
    },
)

RECIPIENT_CATEGORY_COLLECTION = Schema.collection(
    id=ShapeID("borneo#RecipientCategoryCollection"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": RECIPIENT_CATEGORY,
        },
    },
)

COUNTRY_LIST = Schema.collection(
    id=ShapeID("borneo#CountryList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": COUNTRY_CODE,
        },
    },
)

RECIPIENT_DPA = Schema(
    id=ShapeID("borneo#RecipientDpa"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 255,
            },
        ),
    ],
)

RECIPIENT_DPA_STATUS = Schema.collection(
    id=ShapeID("borneo#RecipientDpaStatus"),
    type=ShapeType.ENUM,
    members={
        "ATTACHED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="attached"),
            ],
        },
        "NOT_REQUIRED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="notRequired"),
            ],
        },
        "REQUESTED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="requested"),
            ],
        },
    },
)

RECIPIENT_LAWFUL_BASIS = Schema(
    id=ShapeID("borneo#RecipientLawfulBasis"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#pattern"),
            value="^([A-Za-z0-9-._]{1,36}|adequacyDecision|appropriateSafeguards|bcrs|euData|noTransfers|sccsTransfers|specificSituationExemption)$",
        ),
    ],
)

WARRANTY_LIST = Schema.collection(
    id=ShapeID("borneo#WarrantyList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": RECIPIENT_LAWFUL_BASIS,
        },
    },
)

STATE = Schema.collection(
    id=ShapeID("borneo#State"),
    type=ShapeType.ENUM,
    members={
        "AL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AL"),
            ],
        },
        "AK": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AK"),
            ],
        },
        "AR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AR"),
            ],
        },
        "AZ": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AZ"),
            ],
        },
        "CA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="CA"),
            ],
        },
        "CO": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="CO"),
            ],
        },
        "CT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="CT"),
            ],
        },
        "DC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DC"),
            ],
        },
        "DE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DE"),
            ],
        },
        "FL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="FL"),
            ],
        },
        "GA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="GA"),
            ],
        },
        "HI": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="HI"),
            ],
        },
        "IA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="IA"),
            ],
        },
        "ID": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ID"),
            ],
        },
        "IL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="IL"),
            ],
        },
        "IN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="IN"),
            ],
        },
        "KS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="KS"),
            ],
        },
        "KY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="KY"),
            ],
        },
        "LA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="LA"),
            ],
        },
        "MA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MA"),
            ],
        },
        "MD": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MD"),
            ],
        },
        "ME": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ME"),
            ],
        },
        "MI": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MI"),
            ],
        },
        "MN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MN"),
            ],
        },
        "MO": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MO"),
            ],
        },
        "MS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MS"),
            ],
        },
        "MT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MT"),
            ],
        },
        "NC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NC"),
            ],
        },
        "ND": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="ND"),
            ],
        },
        "NE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NE"),
            ],
        },
        "NH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NH"),
            ],
        },
        "NJ": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NJ"),
            ],
        },
        "NM": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NM"),
            ],
        },
        "NV": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NV"),
            ],
        },
        "NY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NY"),
            ],
        },
        "OH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="OH"),
            ],
        },
        "OK": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="OK"),
            ],
        },
        "OR": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="OR"),
            ],
        },
        "PA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="PA"),
            ],
        },
        "RI": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="RI"),
            ],
        },
        "SC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="SC"),
            ],
        },
        "SD": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="SD"),
            ],
        },
        "TN": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="TN"),
            ],
        },
        "TX": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="TX"),
            ],
        },
        "UT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="UT"),
            ],
        },
        "VA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="VA"),
            ],
        },
        "VT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="VT"),
            ],
        },
        "WA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="WA"),
            ],
        },
        "WI": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="WI"),
            ],
        },
        "WV": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="WV"),
            ],
        },
        "WY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="WY"),
            ],
        },
    },
)

RECIPIENT_STATUS = Schema.collection(
    id=ShapeID("borneo#RecipientStatus"),
    type=ShapeType.ENUM,
    members={
        "ARCHIVED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="archived"),
            ],
        },
        "VALIDATED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="validated"),
            ],
        },
    },
)

PROCESSING_ACTIVITY_RECIPIENT_MEMBER = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityRecipientMember"),
    members={
        "name": {
            "target": RECIPIENT_NAME,
        },
        "businessName": {
            "target": RECIPIENT_BUSINESS_NAME,
        },
        "status": {
            "target": RECIPIENT_STATUS,
        },
        "categories": {
            "target": RECIPIENT_CATEGORY_COLLECTION,
        },
        "role": {
            "target": RECIPIENT_ROLE,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "state": {
            "target": STATE,
        },
        "dpa": {
            "target": RECIPIENT_DPA,
        },
        "dpaFiles": {
            "target": UUID_COLLECTION,
        },
        "dpaStatus": {
            "target": RECIPIENT_DPA_STATUS,
        },
        "recipientModelId": {
            "target": UUID,
        },
        "recipientWarranties": {
            "target": WARRANTY_LIST,
        },
        "dataStorageLocation": {
            "target": COUNTRY_LIST,
        },
        "discoverySource": {
            "target": DISCOVERY_SOURCE_LIST,
        },
        "discoveredDate": {
            "target": TIMESTAMP,
        },
        "recipientId": {
            "target": UUID,
        },
        "comment": {
            "target": STRING,
        },
    },
)

PROCESSING_ACTIVITY_RECIPIENT_LIST = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityRecipientList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": PROCESSING_ACTIVITY_RECIPIENT_MEMBER,
        },
    },
)

PROCESSING_ACTIVITY_STATUS = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityStatus"),
    type=ShapeType.ENUM,
    members={
        "PA_IN_DRAFT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="paInDraft"),
            ],
        },
        "PENDING_TA": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="pendingTA"),
            ],
        },
        "TA_IN_DRAFT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="taInDraft"),
            ],
        },
        "DPIA_OPTIONAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dpiaOptional"),
            ],
        },
        "DPIA_RECOMMENDED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dpiaRecommended"),
            ],
        },
        "DPIA_REQUIRED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dpiaRequired"),
            ],
        },
        "DPIA_IN_DRAFT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dpiaInDraft"),
            ],
        },
        "DPIA_COMPLETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dpiaCompleted"),
            ],
        },
    },
)

DESCRIBE_PROCESSING_ACTIVITY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeProcessingActivityOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#ProcessingActivityRecord",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "processingActivityId": {
            "target": PROCESSING_ACTIVITY_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "active": {
            "target": BOOLEAN,
        },
        "additionalInfo": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "additionalInfoFiles": {
            "target": UUID_COLLECTION,
        },
        "companyRole": {
            "target": COMPANY_ROLE,
        },
        "createdBy": {
            "target": STRING,
        },
        "dataSources": {
            "target": PROCESSING_ACTIVITIY_DATA_SOURCE_COLLECTION,
        },
        "dataSubjects": {
            "target": DATA_SUBJECT_COLLECTION,
        },
        "dataTypes": {
            "target": DATA_TYPE_COLLECTION,
        },
        "lawfulBasis": {
            "target": LAWFUL_BASIS_COLLECTION,
        },
        "modelId": {
            "target": UUID,
        },
        "name": {
            "target": PRIVACY_OPS_STANDARD_TEXT,
        },
        "purpose": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "recipientObjects": {
            "target": PROCESSING_ACTIVITY_RECIPIENT_LIST,
        },
        "retentionPeriod": {
            "target": RETENTION_PERIOD,
        },
        "retentionPeriodComment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "status": {
            "target": PROCESSING_ACTIVITY_STATUS,
        },
        "departmentObjects": {
            "target": PROCESSING_ACTIVITY_DEPARTMENT_LIST,
        },
        "assetObjects": {
            "target": PROCESSING_ACTIVITY_ASSET_LIST,
        },
        "contactPersonEmployee": {
            "target": PROCESSING_ACTIVITY_EMPLOYEE,
        },
        "infotypes": {
            "target": INFOTYPES_LIST,
        },
        "infotypeCategories": {
            "target": INFOTYPE_CATEGORY_LIST,
        },
        "infotypeVolume": {
            "target": INFOTYPE_VOLUME,
        },
        "processingFrequency": {
            "target": DATA_PROCESSING_FREQUENCY,
        },
        "processingFrequencyComment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "isDataStored": {
            "target": BOOLEAN,
        },
        "areAccessRequestsManaged": {
            "target": BOOLEAN,
        },
        "managementMethods": {
            "target": MANAGEMENT_METHOD_COLLECTION,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "language": {
            "target": LANGUAGE_TYPE,
        },
    },
)

PROCESSING_ACTIVITY_SELECT_FILTER = Schema.collection(
    id=ShapeID("borneo#ProcessingActivitySelectFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "departments": {
            "target": UNIQUE_STRING_LIST,
        },
        "assets": {
            "target": UNIQUE_STRING_LIST,
        },
        "owners": {
            "target": UNIQUE_STRING_LIST,
        },
        "status": {
            "target": UNIQUE_STRING_LIST,
        },
        "recipients": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataTypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "infotypes": {
            "target": UNIQUE_STRING_LIST,
        },
        "infotypeCategories": {
            "target": UNIQUE_STRING_LIST,
        },
        "employees": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataSubjects": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_PROCESSING_ACTIVITIES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivitiesInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#ProcessingActivityListInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": PROCESSING_ACTIVITY_SELECT_FILTER,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

PROCESSING_ACTIVITY_LIST_RECORD = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityListRecord"),
    members={
        "processingActivityId": {
            "target": PROCESSING_ACTIVITY_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "active": {
            "target": BOOLEAN,
        },
        "departmentObjects": {
            "target": PROCESSING_ACTIVITY_DEPARTMENT_LIST,
        },
        "name": {
            "target": PRIVACY_OPS_STANDARD_TEXT,
        },
        "recipientObjects": {
            "target": PROCESSING_ACTIVITY_RECIPIENT_LIST,
        },
        "status": {
            "target": PROCESSING_ACTIVITY_STATUS,
        },
        "createdBy": {
            "target": STRING,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

PROCESSING_ACTIVITY_LIST = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": PROCESSING_ACTIVITY_LIST_RECORD,
        },
    },
)

LIST_PROCESSING_ACTIVITIES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivitiesOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#ProcessingActivityListOutput",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "processingActivities": {
            "target": PROCESSING_ACTIVITY_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "total": {
            "target": INTEGER,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

EXPORT_TYPE = Schema.collection(
    id=ShapeID("borneo#ExportType"),
    type=ShapeType.ENUM,
    members={
        "CSV": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="csv"),
            ],
        },
        "PDF": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="pdf"),
            ],
        },
        "DOC": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="doc"),
            ],
        },
    },
)

EXPORT_TYPE_LIST = Schema.collection(
    id=ShapeID("borneo#ExportTypeList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": EXPORT_TYPE,
        },
    },
)

PROCESSING_ACTIVITY_EXPORT_FILTERS = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityExportFilters"),
    members={
        "processingActivityId": {
            "target": UUID,
        },
        "status": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_PROCESSING_ACTIVITIES_EXPORT_INPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivitiesExportInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "exportTypes": {
            "target": EXPORT_TYPE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "filter": {
            "target": PROCESSING_ACTIVITY_EXPORT_FILTERS,
        },
    },
)

EXPORTED_DATA_URL = Schema.collection(
    id=ShapeID("borneo#ExportedDataUrl"),
    members={
        "url": {
            "target": STRING,
        },
        "type": {
            "target": EXPORT_TYPE,
        },
    },
)

URL_LIST = Schema.collection(
    id=ShapeID("borneo#UrlList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": EXPORTED_DATA_URL,
        },
    },
)

LIST_PROCESSING_ACTIVITIES_EXPORT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivitiesExportOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "urlList": {
            "target": URL_LIST,
        },
    },
)

LIST_PROCESSING_ACTIVITY_FILTER_TYPE = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivityFilterType"),
    type=ShapeType.ENUM,
    members={
        "OWNER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="owner"),
            ],
        },
        "RECIPIENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="recipient"),
            ],
        },
        "STATUS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="status"),
            ],
        },
        "DEPARTMENT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="department"),
            ],
        },
        "DATA_SUBJECT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="dataSubject"),
            ],
        },
    },
)

LIST_PROCESSING_ACTIVITY_FILTER_INPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivityFilterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filterType": {
            "target": LIST_PROCESSING_ACTIVITY_FILTER_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

LIST_PROCESSING_ACTIVITY_FILTER_MEMBER = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivityFilterMember"),
    members={
        "id": {
            "target": STRING,
        },
        "name": {
            "target": STRING,
        },
    },
)

PROCESSING_ACTIVITY_FILTER_OUTPUT_LIST = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityFilterOutputList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": LIST_PROCESSING_ACTIVITY_FILTER_MEMBER,
        },
    },
)

LIST_PROCESSING_ACTIVITY_FILTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivityFilterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "enteries": {
            "target": PROCESSING_ACTIVITY_FILTER_OUTPUT_LIST,
        },
    },
)

REMOVE_PROCESSING_ACTIVITY_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveProcessingActivityInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "processingActivityId": {
            "target": PROCESSING_ACTIVITY_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_PROCESSING_ACTIVITY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveProcessingActivityOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_PROCESSING_ACTIVITY_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateProcessingActivityInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "processingActivityId": {
            "target": PROCESSING_ACTIVITY_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "active": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "additionalInfo": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "additionalInfoFiles": {
            "target": UUID_COLLECTION,
        },
        "assets": {
            "target": UUID_COLLECTION,
        },
        "companyRole": {
            "target": COMPANY_ROLE,
        },
        "contactPerson": {
            "target": UUID,
        },
        "dataSources": {
            "target": PROCESSING_ACTIVITIY_DATA_SOURCE_COLLECTION,
        },
        "dataSubjects": {
            "target": DATA_SUBJECT_COLLECTION,
        },
        "dataTypes": {
            "target": DATA_TYPE_COLLECTION,
        },
        "departments": {
            "target": UUID_COLLECTION,
        },
        "lawfulBasis": {
            "target": LAWFUL_BASIS_COLLECTION,
        },
        "modelId": {
            "target": UUID,
        },
        "name": {
            "target": PRIVACY_OPS_STANDARD_TEXT,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "purpose": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "recipients": {
            "target": RECIPIENT_COLLECTION,
        },
        "retentionPeriod": {
            "target": RETENTION_PERIOD,
        },
        "retentionPeriodComment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "infotypes": {
            "target": INFOTYPES_LIST,
        },
        "infotypeCategories": {
            "target": INFOTYPE_CATEGORY_LIST,
        },
        "infotypeVolume": {
            "target": INFOTYPE_VOLUME,
        },
        "processingFrequency": {
            "target": DATA_PROCESSING_FREQUENCY,
        },
        "processingFrequencyComment": {
            "target": PRIVACY_OPS_LONG_TEXT,
        },
        "isDataStored": {
            "target": BOOLEAN,
        },
        "areAccessRequestsManaged": {
            "target": BOOLEAN,
        },
        "managementMethods": {
            "target": MANAGEMENT_METHOD_COLLECTION,
        },
    },
)

UPDATE_PROCESSING_ACTIVITY_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateProcessingActivityOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

CREATE_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": RECIPIENT_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "businessName": {
            "target": RECIPIENT_BUSINESS_NAME,
        },
        "status": {
            "target": RECIPIENT_STATUS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "categories": {
            "target": RECIPIENT_CATEGORY_COLLECTION,
        },
        "role": {
            "target": RECIPIENT_ROLE,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "state": {
            "target": STATE,
        },
        "dpa": {
            "target": RECIPIENT_DPA,
        },
        "dpaFiles": {
            "target": UUID_COLLECTION,
        },
        "dpaStatus": {
            "target": RECIPIENT_DPA_STATUS,
        },
        "recipientModelId": {
            "target": UUID,
        },
        "dataStorageLocation": {
            "target": COUNTRY_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "recipientWarranties": {
            "target": WARRANTY_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "fromDiscoveredRecipientId": {
            "target": UUID,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

CREATE_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateRecipientOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeRecipientOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "name": {
            "target": RECIPIENT_NAME,
        },
        "businessName": {
            "target": RECIPIENT_BUSINESS_NAME,
        },
        "status": {
            "target": RECIPIENT_STATUS,
        },
        "categories": {
            "target": RECIPIENT_CATEGORY_COLLECTION,
        },
        "role": {
            "target": RECIPIENT_ROLE,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "state": {
            "target": STATE,
        },
        "dpa": {
            "target": RECIPIENT_DPA,
        },
        "dpaFiles": {
            "target": UUID_COLLECTION,
        },
        "dpaStatus": {
            "target": RECIPIENT_DPA_STATUS,
        },
        "recipientModelId": {
            "target": UUID,
        },
        "recipientWarranties": {
            "target": WARRANTY_LIST,
        },
        "dataStorageLocation": {
            "target": COUNTRY_LIST,
        },
        "discoverySource": {
            "target": DISCOVERY_SOURCE_LIST,
        },
        "discoveredDate": {
            "target": TIMESTAMP,
        },
    },
)

LIST_PROCESSING_ACTIVITIES_OF_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivitiesOfRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "nextToken": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
        "pageSize": {
            "target": PAGE_SIZE,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
        "sort": {
            "target": SORT_RECORDS,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
    },
)

PROCESSING_ACTIVITY_OF_RECIPIENT_MEMBER = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityOfRecipientMember"),
    members={
        "processingActivityId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": PRIVACY_OPS_STANDARD_TEXT,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "active": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "updatedAt": {
            "target": TIMESTAMP,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "createdBy": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

PROCESSING_ACTIVITY_OF_RECIPIENT_LIST = Schema.collection(
    id=ShapeID("borneo#ProcessingActivityOfRecipientList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": PROCESSING_ACTIVITY_OF_RECIPIENT_MEMBER,
        },
    },
)

LIST_PROCESSING_ACTIVITIES_OF_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListProcessingActivitiesOfRecipientOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "processingActivitiesOfRecipient": {
            "target": PROCESSING_ACTIVITY_OF_RECIPIENT_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
        "nextToken": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
        "total": {
            "target": INTEGER,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
    },
)

LIST_RECIPIENT_FILTER_TYPE = Schema.collection(
    id=ShapeID("borneo#ListRecipientFilterType"),
    type=ShapeType.ENUM,
    members={
        "CATEGORIES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="categories"),
            ],
        },
        "ROLE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="role"),
            ],
        },
    },
)

LIST_RECIPIENT_FILTER_INPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientFilterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filterType": {
            "target": LIST_RECIPIENT_FILTER_TYPE,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

RECIPIENT_FILTER_OUTPUT_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#RecipientFilterOutputListMember"),
    members={
        "id": {
            "target": STRING,
        },
        "name": {
            "target": STRING,
        },
    },
)

RECIPIENT_FILTER_OUTPUT_LIST = Schema.collection(
    id=ShapeID("borneo#RecipientFilterOutputList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": RECIPIENT_FILTER_OUTPUT_LIST_MEMBER,
        },
    },
)

LIST_RECIPIENT_FILTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientFilterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "entries": {
            "target": RECIPIENT_FILTER_OUTPUT_LIST,
        },
    },
)

USED_IN_FILTER = Schema.collection(
    id=ShapeID("borneo#UsedInFilter"),
    type=ShapeType.UNION,
    members={
        "recipientsWithoutCompletedPA": {
            "target": BOOLEAN,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "AbbreviationName",
                    ],
                ),
            ],
        },
        "recipientsWithAtleastOnePA": {
            "target": BOOLEAN,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "AbbreviationName",
                    ],
                ),
            ],
        },
    },
)

RECIPIENT_FILTERS = Schema.collection(
    id=ShapeID("borneo#RecipientFilters"),
    members={
        "search": {
            "target": STRING,
        },
        "discoverySource": {
            "target": UNIQUE_STRING_LIST,
        },
        "categories": {
            "target": RECIPIENT_CATEGORY_COLLECTION,
        },
        "role": {
            "target": UNIQUE_STRING_LIST,
        },
        "usedIn": {
            "target": USED_IN_FILTER,
        },
    },
)

LIST_RECIPIENTS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "filter": {
            "target": RECIPIENT_FILTERS,
        },
    },
)

RECIPIENT_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#RecipientListMember"),
    members={
        "recipientId": {
            "target": UUID,
        },
        "name": {
            "target": RECIPIENT_NAME,
        },
        "status": {
            "target": RECIPIENT_STATUS,
        },
        "categories": {
            "target": RECIPIENT_CATEGORY_COLLECTION,
        },
        "role": {
            "target": RECIPIENT_ROLE,
        },
        "discoverySource": {
            "target": DISCOVERY_SOURCE_LIST,
        },
        "lastModification": {
            "target": TIMESTAMP,
        },
        "processingActivities": {
            "target": INTEGER,
        },
    },
)

RECIPIENT_LIST = Schema.collection(
    id=ShapeID("borneo#RecipientList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": RECIPIENT_LIST_MEMBER,
        },
    },
)

LIST_RECIPIENTS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "recipients": {
            "target": RECIPIENT_LIST,
        },
        "nextToken": {
            "target": STRING,
        },
        "total": {
            "target": INTEGER,
        },
    },
)

LIST_RECIPIENTS_EXPORT_INPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientsExportInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "exportTypes": {
            "target": EXPORT_TYPE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

LIST_RECIPIENTS_EXPORT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientsExportOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "urlList": {
            "target": URL_LIST,
        },
    },
)

LIST_RECIPIENTS_FOR_FILTER_INPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientsForFilterInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
)

RECIPIENT_FOR_FILTER_MEMBER = Schema.collection(
    id=ShapeID("borneo#RecipientForFilterMember"),
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": RECIPIENT_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

RECIPIENTS_FOR_FILTER_LIST = Schema.collection(
    id=ShapeID("borneo#RecipientsForFilterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": RECIPIENT_FOR_FILTER_MEMBER,
        },
    },
)

LIST_RECIPIENTS_FOR_FILTER_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListRecipientsForFilterOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "recipients": {
            "target": RECIPIENTS_FOR_FILTER_LIST,
        },
    },
)

REMOVE_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveRecipientOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_RECIPIENT_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateRecipientInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "recipientId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "name": {
            "target": RECIPIENT_NAME,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "businessName": {
            "target": RECIPIENT_BUSINESS_NAME,
        },
        "status": {
            "target": RECIPIENT_STATUS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "categories": {
            "target": RECIPIENT_CATEGORY_COLLECTION,
        },
        "role": {
            "target": RECIPIENT_ROLE,
        },
        "country": {
            "target": COUNTRY_CODE,
        },
        "state": {
            "target": STATE,
        },
        "dpa": {
            "target": RECIPIENT_DPA,
        },
        "dpaFiles": {
            "target": UUID_COLLECTION,
        },
        "dpaStatus": {
            "target": RECIPIENT_DPA_STATUS,
        },
        "dataStorageLocation": {
            "target": COUNTRY_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "recipientWarranties": {
            "target": WARRANTY_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

UPDATE_RECIPIENT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateRecipientOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

DESCRIBE_INVENTORY_RESOURCE_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeInventoryResourceInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

SCAN_STATUS = Schema.collection(
    id=ShapeID("borneo#ScanStatus"),
    type=ShapeType.ENUM,
    members={
        "SCHEDULED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="scheduled"),
            ],
        },
        "PENDING": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="pending"),
            ],
        },
        "INPROGRESS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="inprogress"),
            ],
        },
        "PAUSED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="paused"),
            ],
        },
        "COMPLETED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="completed"),
            ],
        },
        "TERMINATED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="terminated"),
            ],
        },
    },
)

SCAN_TYPE = Schema.collection(
    id=ShapeID("borneo#ScanType"),
    type=ShapeType.ENUM,
    members={
        "SAMPLE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="sample"),
            ],
        },
        "FULL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="full"),
            ],
        },
    },
)

SCAN_INFORMATION = Schema.collection(
    id=ShapeID("borneo#ScanInformation"),
    members={
        "type": {
            "target": SCAN_TYPE,
        },
        "status": {
            "target": SCAN_STATUS,
        },
        "lastScan": {
            "target": TIMESTAMP,
        },
    },
)

DESCRIBE_INVENTORY_RESOURCE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeInventoryResourceOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "owner": {
            "target": OWNER_OBJECT_LIST,
        },
        "status": {
            "target": RESOURCE_STATUS,
        },
        "source": {
            "target": SOURCE_OF_RESOURCE,
        },
        "parentId": {
            "target": STRING,
        },
        "failedRules": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataClassification": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataCategories": {
            "target": UNIQUE_STRING_LIST,
        },
        "scan": {
            "target": SCAN_INFORMATION,
        },
        "firstSeen": {
            "target": STRING,
        },
        "lastUpdated": {
            "target": STRING,
        },
        "severityScore": {
            "target": INTEGER,
        },
        "properties": {
            "target": OPEN_PROPERTIES,
        },
        "aka": {
            "target": STRING,
        },
        "issueId": {
            "target": ISSUE_ID,
        },
    },
)

DATA_SOURCE_CATEGORY = Schema.collection(
    id=ShapeID("borneo#DataSourceCategory"),
    type=ShapeType.ENUM,
    members={
        "AWS_DATA_STORES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AWSDataStores"),
            ],
        },
        "GCP_DATA_STORES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="GCPDataStores"),
            ],
        },
        "STANDALONE_DATA_STORES": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="StandaloneDataStores"),
            ],
        },
        "CLOUD_APPLICATIONS": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="CloudApplications"),
            ],
        },
        "DISCOVERED_APPLICATIONS": {
            "target": UNIT,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#enumValue"), value="DiscoveredApplications"
                ),
            ],
        },
    },
)

DATA_SOURCE_CATEGORY_LIST = Schema.collection(
    id=ShapeID("borneo#DataSourceCategoryList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": DATA_SOURCE_CATEGORY,
        },
    },
)

TIMESTAMP_COMPARATOR = Schema.collection(
    id=ShapeID("borneo#TimestampComparator"),
    type=ShapeType.ENUM,
    traits=[
        Trait(
            id=ShapeID("smithy.api#suppress"),
            value=[
                "ShouldHaveUsedTimestamp",
            ],
        ),
    ],
    members={
        "AFTER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="after"),
            ],
        },
        "BEFORE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="before"),
            ],
        },
    },
)

TIME_FILTER = Schema.collection(
    id=ShapeID("borneo#TimeFilter"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": TIMESTAMP_COMPARATOR,
        },
        "value": {
            "target": TIMESTAMP,
        },
    },
)

INVENTORY_TAG_FILTER = Schema.collection(
    id=ShapeID("borneo#InventoryTagFilter"),
    members={
        "source": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tagKey": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tagValue": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

INVENTORY_TAG_FILTER_LIST = Schema.collection(
    id=ShapeID("borneo#InventoryTagFilterList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": INVENTORY_TAG_FILTER,
        },
    },
)

UNIQUE_INTEGER_LIST = Schema.collection(
    id=ShapeID("borneo#UniqueIntegerList"),
    type=ShapeType.LIST,
    traits=[
        Trait(id=ShapeID("smithy.api#uniqueItems")),
    ],
    members={
        "member": {
            "target": INTEGER,
        },
    },
)

INVENTORY_LIST_FILTER = Schema.collection(
    id=ShapeID("borneo#InventoryListFilter"),
    members={
        "accountId": {
            "target": STRING,
        },
        "region": {
            "target": STRING,
        },
        "search": {
            "target": STRING,
        },
        "resourceType": {
            "target": STRING,
        },
        "resourceIds": {
            "target": UNIQUE_STRING_LIST,
        },
        "firstSeen": {
            "target": TIME_FILTER,
        },
        "noOwner": {
            "target": BOOLEAN,
        },
        "hasOwner": {
            "target": BOOLEAN,
        },
        "hasPii": {
            "target": BOOLEAN,
        },
        "dataRisks": {
            "target": UNIQUE_STRING_LIST,
        },
        "severityScore": {
            "target": UNIQUE_INTEGER_LIST,
        },
        "hideBorneoResources": {
            "target": BOOLEAN,
            "traits": [
                Trait(id=ShapeID("smithy.api#default"), value=False),
            ],
        },
        "dataSourceCategories": {
            "target": DATA_SOURCE_CATEGORY_LIST,
        },
        "classification": {
            "target": UNIQUE_STRING_LIST,
        },
        "scannableResourceTypes": {
            "target": BOOLEAN,
        },
        "resourceTags": {
            "target": INVENTORY_TAG_FILTER_LIST,
        },
    },
)

LIST_INVENTORY_RESOURCES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListInventoryResourcesInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#ListInventoryResourceInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "nextToken": {
            "target": STRING,
        },
        "select": {
            "target": UNIQUE_STRING_LIST,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "filter": {
            "target": INVENTORY_LIST_FILTER,
        },
    },
)

RESOURCE_INVENTORY_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#ResourceInventoryListMember"),
    members={
        "resourceId": {
            "target": RESOURCE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
        },
        "type": {
            "target": STRING,
        },
        "meta": {
            "target": OPEN_PROPERTIES,
        },
        "owner": {
            "target": OWNER_OBJECT_LIST,
        },
        "status": {
            "target": RESOURCE_STATUS,
        },
        "source": {
            "target": SOURCE_OF_RESOURCE,
        },
        "parentId": {
            "target": STRING,
        },
        "failedRules": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataClassification": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataCategories": {
            "target": UNIQUE_STRING_LIST,
        },
        "scan": {
            "target": SCAN_INFORMATION,
        },
        "firstSeen": {
            "target": STRING,
        },
        "lastUpdated": {
            "target": STRING,
        },
        "severityScore": {
            "target": INTEGER,
        },
        "properties": {
            "target": OPEN_PROPERTIES,
        },
        "aka": {
            "target": STRING,
        },
        "issueId": {
            "target": ISSUE_ID,
        },
    },
)

RESOURCE_INVENTORY_LIST = Schema.collection(
    id=ShapeID("borneo#ResourceInventoryList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": RESOURCE_INVENTORY_LIST_MEMBER,
        },
    },
)

LIST_INVENTORY_RESOURCES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListInventoryResourcesOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "resources": {
            "target": RESOURCE_INVENTORY_LIST,
        },
        "count": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

LIST_INVENTORY_RESOURCES_EXPORT_INPUT = Schema.collection(
    id=ShapeID("borneo#ListInventoryResourcesExportInput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#ListInventoryResourceInput",
        ),
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "nextToken": {
            "target": STRING,
        },
        "select": {
            "target": UNIQUE_STRING_LIST,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
        "filter": {
            "target": INVENTORY_LIST_FILTER,
        },
    },
)

LIST_INVENTORY_RESOURCES_EXPORT_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListInventoryResourcesExportOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "url": {
            "target": STRING,
        },
    },
)

CLASSIFICATION_STATS_FILTER = Schema.collection(
    id=ShapeID("borneo#ClassificationStatsFilter"),
    members={
        "classification": {
            "target": STRING,
        },
    },
)

SUMMARIZE_CLASSIFICATION_STATS_INPUT = Schema.collection(
    id=ShapeID("borneo#SummarizeClassificationStatsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": CLASSIFICATION_STATS_FILTER,
        },
    },
)

CLASSIFICATION_STATS_DATA = Schema.collection(
    id=ShapeID("borneo#ClassificationStatsData"),
    members={
        "count": {
            "target": INTEGER,
        },
        "type": {
            "target": STRING,
        },
        "classification": {
            "target": STRING,
        },
    },
)

CLASSIFICATION_STATS_LIST = Schema.collection(
    id=ShapeID("borneo#ClassificationStatsList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": CLASSIFICATION_STATS_DATA,
        },
    },
)

CLASSIFICATION_STATS = Schema.collection(
    id=ShapeID("borneo#ClassificationStats"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": CLASSIFICATION_STATS_LIST,
        },
    },
)

SUMMARIZE_CLASSIFICATION_STATS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#SummarizeClassificationStatsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "result": {
            "target": CLASSIFICATION_STATS,
        },
    },
)

SUMMARIZE_RESOURCE_STATS_INPUT = Schema.collection(
    id=ShapeID("borneo#SummarizeResourceStatsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
)

RESOURCE_STATS_DATA = Schema.collection(
    id=ShapeID("borneo#ResourceStatsData"),
    members={
        "fullScanInspectedBytes": {
            "target": LONG,
        },
        "sampleScanInspectedBytes": {
            "target": LONG,
        },
        "infotypesCount": {
            "target": LONG,
        },
        "infotypeTokensCount": {
            "target": LONG,
        },
        "scannedResources": {
            "target": INTEGER,
        },
        "unscannedResources": {
            "target": INTEGER,
        },
    },
)

RESOURCE_STATS = Schema.collection(
    id=ShapeID("borneo#ResourceStats"),
    type=ShapeType.MAP,
    members={
        "key": {
            "target": STRING,
        },
        "value": {
            "target": RESOURCE_STATS_DATA,
        },
    },
)

SUMMARIZE_RESOURCE_STATS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#SummarizeResourceStatsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "result": {
            "target": RESOURCE_STATS,
        },
    },
)

TAG_KEY = Schema(
    id=ShapeID("borneo#TagKey"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 63,
            },
        ),
        Trait(id=ShapeID("smithy.api#pattern"), value="^[a-zA-Z0-9\\s+\\-=._:/@]*$"),
    ],
)

TAG_RESOURCES_FILTER = Schema.collection(
    id=ShapeID("borneo#TagResourcesFilter"),
    members={
        "accountId": {
            "target": STRING,
        },
        "region": {
            "target": STRING,
        },
        "search": {
            "target": STRING,
        },
        "resourceType": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

TAG_RESOURCE_UNION = Schema.collection(
    id=ShapeID("borneo#TagResourceUnion"),
    type=ShapeType.UNION,
    members={
        "filter": {
            "target": TAG_RESOURCES_FILTER,
        },
        "resourceIds": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

TAG_VALUE = Schema(
    id=ShapeID("borneo#TagValue"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "max": 63,
            },
        ),
        Trait(id=ShapeID("smithy.api#pattern"), value="^[a-zA-Z0-9\\s+\\-=._:/@]*$"),
    ],
)

UNTAG_RESOURCES_INPUT = Schema.collection(
    id=ShapeID("borneo#UntagResourcesInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "tagKey": {
            "target": TAG_KEY,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "tagValue": {
            "target": TAG_VALUE,
        },
        "tagResources": {
            "target": TAG_RESOURCE_UNION,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

TAGGING_RESULT = Schema.collection(
    id=ShapeID("borneo#TaggingResult"),
    members={
        "resourceId": {
            "target": STRING,
        },
        "status": {
            "target": STRING,
        },
    },
)

TAGGING_RESULTS_LIST = Schema.collection(
    id=ShapeID("borneo#TaggingResultsList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": TAGGING_RESULT,
        },
    },
)

UNTAG_RESOURCES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UntagResourcesOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "results": {
            "target": TAGGING_RESULTS_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#notProperty")),
            ],
        },
    },
)

SCAN_NAME = Schema(
    id=ShapeID("borneo#ScanName"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9.,_ @+=-]{1,100}$"),
    ],
)

PERCENTAGE = Schema(
    id=ShapeID("borneo#Percentage"),
    type=ShapeType.FLOAT,
    traits=[
        Trait(id=ShapeID("smithy.api#box")),
        Trait(
            id=ShapeID("smithy.api#range"),
            value={
                "min": 0,
                "max": 100,
            },
        ),
    ],
)

SCAN_LIMITS = Schema.collection(
    id=ShapeID("borneo#ScanLimits"),
    members={
        "samplePercentage": {
            "target": PERCENTAGE,
        },
        "maxCumulativeDataSizeMb": {
            "target": INTEGER,
        },
        "itemsPerBatch": {
            "target": INTEGER,
        },
        "sampleDurationMinutes": {
            "target": INTEGER,
        },
    },
)

MONTH = Schema.collection(
    id=ShapeID("borneo#Month"),
    type=ShapeType.ENUM,
    members={
        "JANUARY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="JANUARY"),
            ],
        },
        "FEBRUARY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="FEBRUARY"),
            ],
        },
        "MARCH": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MARCH"),
            ],
        },
        "APRIL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="APRIL"),
            ],
        },
        "MAY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="MAY"),
            ],
        },
        "JUNE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="JUNE"),
            ],
        },
        "JULY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="JULY"),
            ],
        },
        "AUGUST": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="AUGUST"),
            ],
        },
        "SEPTEMBER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="SEPTEMBER"),
            ],
        },
        "OCTOBER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="OCTOBER"),
            ],
        },
        "NOVEMBER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="NOVEMBER"),
            ],
        },
        "DECEMBER": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="DECEMBER"),
            ],
        },
    },
)

CALENDAR_SPEC = Schema.collection(
    id=ShapeID("borneo#CalendarSpec"),
    members={
        "second": {
            "target": INTEGER,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#range"),
                    value={
                        "min": 0,
                        "max": 59,
                    },
                ),
            ],
        },
        "minute": {
            "target": INTEGER,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#range"),
                    value={
                        "min": 0,
                        "max": 59,
                    },
                ),
            ],
        },
        "hour": {
            "target": INTEGER,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#range"),
                    value={
                        "min": 0,
                        "max": 23,
                    },
                ),
            ],
        },
        "dayOfMonth": {
            "target": INTEGER,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#range"),
                    value={
                        "min": 1,
                        "max": 31,
                    },
                ),
            ],
        },
        "month": {
            "target": MONTH,
        },
        "year": {
            "target": INTEGER,
        },
    },
)

CALENDAR_SPEC_LIST = Schema.collection(
    id=ShapeID("borneo#CalendarSpecList"),
    type=ShapeType.LIST,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 1,
                "max": 1,
            },
        ),
    ],
    members={
        "member": {
            "target": CALENDAR_SPEC,
        },
    },
)

SCAN_SCHEDULE = Schema.collection(
    id=ShapeID("borneo#ScanSchedule"),
    members={
        "calendars": {
            "target": CALENDAR_SPEC_LIST,
        },
        "timezone": {
            "target": STRING,
        },
    },
)

SCHEDULE_TYPE = Schema.collection(
    id=ShapeID("borneo#ScheduleType"),
    type=ShapeType.ENUM,
    members={
        "ONCE": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="once"),
            ],
        },
        "CRON": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="cron"),
            ],
        },
    },
)

CREATE_SCAN_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateScanInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "name": {
            "target": SCAN_NAME,
        },
        "scanType": {
            "target": SCAN_TYPE,
        },
        "resourceType": {
            "target": STRING,
        },
        "resources": {
            "target": SCAN_RESOURCES,
        },
        "connectorId": {
            "target": CONNECTOR_ID,
        },
        "scheduleType": {
            "target": SCHEDULE_TYPE,
        },
        "cron": {
            "target": CRON_VALUES,
        },
        "scanFilter": {
            "target": SCAN_FILTER_LIST,
        },
        "inspectionPolicy": {
            "target": INSPECTION_POLICY,
        },
        "scanLimits": {
            "target": SCAN_LIMITS,
        },
        "schedule": {
            "target": SCAN_SCHEDULE,
        },
    },
)

CREATE_SCAN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateScanOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DATA_PLANE_NAME = Schema(
    id=ShapeID("borneo#DataPlaneName"),
    type=ShapeType.STRING,
    traits=[
        Trait(id=ShapeID("smithy.api#pattern"), value="^[A-Za-z0-9.,_ @+=-]{1,100}$"),
    ],
)

DESCRIBE_SCAN_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeScanInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

SCAN_META = Schema.collection(
    id=ShapeID("borneo#ScanMeta"),
)

SCAN_DATA_PROCESSED = Schema.collection(
    id=ShapeID("borneo#ScanDataProcessed"),
    members={
        "readFromSourceBytes": {
            "target": LONG,
        },
        "inspectedBytes": {
            "target": LONG,
        },
        "extractedBytes": {
            "target": LONG,
        },
    },
)

STATE_CHANGE_EVENTS = Schema.collection(
    id=ShapeID("borneo#StateChangeEvents"),
    members={
        "status": {
            "target": SCAN_STATUS,
        },
        "previousStatus": {
            "target": SCAN_STATUS,
        },
        "epoch": {
            "target": LONG,
        },
    },
)

STATE_CHANGE_EVENTS_LIST = Schema.collection(
    id=ShapeID("borneo#StateChangeEventsList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": STATE_CHANGE_EVENTS,
        },
    },
)

SCAN_STATS = Schema.collection(
    id=ShapeID("borneo#ScanStats"),
    members={
        "stateChangeEvents": {
            "target": STATE_CHANGE_EVENTS_LIST,
        },
        "dataProcessed": {
            "target": SCAN_DATA_PROCESSED,
        },
    },
)

DESCRIBE_SCAN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeScanOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"), value="borneo#ScanRecord"
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": SCAN_NAME,
        },
        "status": {
            "target": SCAN_STATUS,
        },
        "scanType": {
            "target": SCAN_TYPE,
        },
        "resourceType": {
            "target": STRING,
        },
        "resources": {
            "target": SCAN_RESOURCES,
        },
        "connectorId": {
            "target": CONNECTOR_ID,
        },
        "connectorType": {
            "target": STRING,
        },
        "dataPlaneId": {
            "target": DATA_PLANE_ID,
        },
        "dataPlaneName": {
            "target": DATA_PLANE_NAME,
        },
        "dataPlaneSlug": {
            "target": STRING,
        },
        "scheduleType": {
            "target": SCHEDULE_TYPE,
        },
        "cron": {
            "target": CRON_VALUES,
        },
        "scanFilter": {
            "target": SCAN_FILTER_LIST,
        },
        "scanLimits": {
            "target": SCAN_LIMITS,
        },
        "inspectionPolicy": {
            "target": INSPECTION_POLICY,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "meta": {
            "target": SCAN_META,
        },
        "stats": {
            "target": SCAN_STATS,
        },
        "elapsedTimeMs": {
            "target": LONG,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "schedule": {
            "target": SCAN_SCHEDULE,
        },
        "nextExecution": {
            "target": TIMESTAMP,
        },
    },
)

SCAN_SELECT_FILTER = Schema.collection(
    id=ShapeID("borneo#ScanSelectFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "scanType": {
            "target": UNIQUE_STRING_LIST,
        },
        "connectorId": {
            "target": UNIQUE_STRING_LIST,
        },
        "resources": {
            "target": UNIQUE_STRING_LIST,
        },
        "resourceType": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataPlaneName": {
            "target": UNIQUE_STRING_LIST,
        },
        "dataPlaneId": {
            "target": UNIQUE_STRING_LIST,
        },
        "status": {
            "target": UNIQUE_STRING_LIST,
        },
        "accountId": {
            "target": UNIQUE_STRING_LIST,
        },
        "gcpProjectId": {
            "target": UNIQUE_STRING_LIST,
        },
        "infoTypes": {
            "target": INFO_TYPES_COMBINATION_FILTER,
        },
    },
)

LIST_SCANS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListScansInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": SCAN_SELECT_FILTER,
        },
        "select": {
            "target": UNIQUE_STRING_LIST,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "getNextExecution": {
            "target": BOOLEAN,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

SCAN_RECORD = Schema.collection(
    id=ShapeID("borneo#ScanRecord"),
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": SCAN_NAME,
        },
        "status": {
            "target": SCAN_STATUS,
        },
        "scanType": {
            "target": SCAN_TYPE,
        },
        "resourceType": {
            "target": STRING,
        },
        "resources": {
            "target": SCAN_RESOURCES,
        },
        "connectorId": {
            "target": CONNECTOR_ID,
        },
        "connectorType": {
            "target": STRING,
        },
        "dataPlaneId": {
            "target": DATA_PLANE_ID,
        },
        "dataPlaneName": {
            "target": DATA_PLANE_NAME,
        },
        "dataPlaneSlug": {
            "target": STRING,
        },
        "scheduleType": {
            "target": SCHEDULE_TYPE,
        },
        "cron": {
            "target": CRON_VALUES,
        },
        "scanFilter": {
            "target": SCAN_FILTER_LIST,
        },
        "scanLimits": {
            "target": SCAN_LIMITS,
        },
        "inspectionPolicy": {
            "target": INSPECTION_POLICY,
        },
        "snapshot": {
            "target": INSPECTION_RESULT_SNAPSHOT,
        },
        "meta": {
            "target": SCAN_META,
        },
        "stats": {
            "target": SCAN_STATS,
        },
        "elapsedTimeMs": {
            "target": LONG,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "schedule": {
            "target": SCAN_SCHEDULE,
        },
        "nextExecution": {
            "target": TIMESTAMP,
        },
    },
)

SCANS_LIST = Schema.collection(
    id=ShapeID("borneo#ScansList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": SCAN_RECORD,
        },
    },
)

LIST_SCANS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListScansOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "scans": {
            "target": SCANS_LIST,
        },
        "total": {
            "target": INTEGER,
        },
        "nextToken": {
            "target": STRING,
        },
    },
)

PAUSE_SCAN_INPUT = Schema.collection(
    id=ShapeID("borneo#PauseScanInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

PAUSE_SCAN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#PauseScanOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

RESUME_SCAN_INPUT = Schema.collection(
    id=ShapeID("borneo#ResumeScanInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

RESUME_SCAN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ResumeScanOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

STOP_SCAN_INPUT = Schema.collection(
    id=ShapeID("borneo#StopScanInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

STOP_SCAN_OUTPUT = Schema.collection(
    id=ShapeID("borneo#StopScanOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "scanId": {
            "target": SCAN_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

THRESHOLD_COMMENT = Schema(
    id=ShapeID("borneo#ThresholdComment"),
    type=ShapeType.STRING,
    traits=[
        Trait(
            id=ShapeID("smithy.api#length"),
            value={
                "min": 3,
                "max": 2000,
            },
        ),
    ],
)

THRESHOLD_STATUS = Schema.collection(
    id=ShapeID("borneo#ThresholdStatus"),
    type=ShapeType.ENUM,
    members={
        "DRAFT": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="draft"),
            ],
        },
        "ACTIVATED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="activated"),
            ],
        },
    },
)

CREATE_THRESHOLD_INPUT = Schema.collection(
    id=ShapeID("borneo#CreateThresholdInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "processingActivityId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "comment": {
            "target": THRESHOLD_COMMENT,
        },
        "extensiveAutomatedEvaluationCharacteristics": {
            "target": BOOLEAN,
        },
        "largeScaleProcessingSensitiveData": {
            "target": BOOLEAN,
        },
        "monitoringPubliclyAccessibleAreas": {
            "target": BOOLEAN,
        },
        "blacklist": {
            "target": BOOLEAN,
        },
        "classifyingDataSubject": {
            "target": BOOLEAN,
        },
        "automatedDecisionMaking": {
            "target": BOOLEAN,
        },
        "systematicMonitoringDataSubject": {
            "target": BOOLEAN,
        },
        "processingConfidentialSensitiveData": {
            "target": BOOLEAN,
        },
        "largeScaleDataProcessing": {
            "target": BOOLEAN,
        },
        "matchingMergingRecordsInvolved": {
            "target": BOOLEAN,
        },
        "processingVulnerableDataSubject": {
            "target": BOOLEAN,
        },
        "innovativeTechnologiesUsed": {
            "target": BOOLEAN,
        },
        "preventDataSubjectsExercisingTheirRights": {
            "target": BOOLEAN,
        },
        "status": {
            "target": THRESHOLD_STATUS,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
    },
)

CREATE_THRESHOLD_OUTPUT = Schema.collection(
    id=ShapeID("borneo#CreateThresholdOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "thresholdId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

DESCRIBE_THRESHOLD_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeThresholdInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "thresholdId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

THRESHOLD_DPIA_STATUS = Schema.collection(
    id=ShapeID("borneo#ThresholdDpiaStatus"),
    type=ShapeType.ENUM,
    members={
        "NECESSARY": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="necessary"),
            ],
        },
        "RECOMMENDED": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="recommended"),
            ],
        },
        "OPTIONAL": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="optional"),
            ],
        },
    },
)

DESCRIBE_THRESHOLD_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeThresholdOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "comment": {
            "target": THRESHOLD_COMMENT,
        },
        "extensiveAutomatedEvaluationCharacteristics": {
            "target": BOOLEAN,
        },
        "largeScaleProcessingSensitiveData": {
            "target": BOOLEAN,
        },
        "monitoringPubliclyAccessibleAreas": {
            "target": BOOLEAN,
        },
        "blacklist": {
            "target": BOOLEAN,
        },
        "classifyingDataSubject": {
            "target": BOOLEAN,
        },
        "automatedDecisionMaking": {
            "target": BOOLEAN,
        },
        "systematicMonitoringDataSubject": {
            "target": BOOLEAN,
        },
        "processingConfidentialSensitiveData": {
            "target": BOOLEAN,
        },
        "largeScaleDataProcessing": {
            "target": BOOLEAN,
        },
        "matchingMergingRecordsInvolved": {
            "target": BOOLEAN,
        },
        "processingVulnerableDataSubject": {
            "target": BOOLEAN,
        },
        "innovativeTechnologiesUsed": {
            "target": BOOLEAN,
        },
        "preventDataSubjectsExercisingTheirRights": {
            "target": BOOLEAN,
        },
        "status": {
            "target": THRESHOLD_STATUS,
        },
        "dpiaStatus": {
            "target": THRESHOLD_DPIA_STATUS,
        },
    },
)

REMOVE_THRESHOLD_INPUT = Schema.collection(
    id=ShapeID("borneo#RemoveThresholdInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "thresholdId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

REMOVE_THRESHOLD_OUTPUT = Schema.collection(
    id=ShapeID("borneo#RemoveThresholdOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

UPDATE_THRESHOLD_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateThresholdInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "thresholdId": {
            "target": UUID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "comment": {
            "target": THRESHOLD_COMMENT,
        },
        "extensiveAutomatedEvaluationCharacteristics": {
            "target": BOOLEAN,
        },
        "largeScaleProcessingSensitiveData": {
            "target": BOOLEAN,
        },
        "monitoringPubliclyAccessibleAreas": {
            "target": BOOLEAN,
        },
        "blacklist": {
            "target": BOOLEAN,
        },
        "classifyingDataSubject": {
            "target": BOOLEAN,
        },
        "automatedDecisionMaking": {
            "target": BOOLEAN,
        },
        "systematicMonitoringDataSubject": {
            "target": BOOLEAN,
        },
        "processingConfidentialSensitiveData": {
            "target": BOOLEAN,
        },
        "largeScaleDataProcessing": {
            "target": BOOLEAN,
        },
        "matchingMergingRecordsInvolved": {
            "target": BOOLEAN,
        },
        "processingVulnerableDataSubject": {
            "target": BOOLEAN,
        },
        "innovativeTechnologiesUsed": {
            "target": BOOLEAN,
        },
        "preventDataSubjectsExercisingTheirRights": {
            "target": BOOLEAN,
        },
        "status": {
            "target": THRESHOLD_STATUS,
        },
    },
)

UPDATE_THRESHOLD_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateThresholdOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

DESCRIBE_TOM_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeTomInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "tomId": {
            "target": TOM_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

TOM_OBJECT_CATEGORY = Schema.collection(
    id=ShapeID("borneo#TomObjectCategory"),
    type=ShapeType.ENUM,
    members={
        "ASSET": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="asset"),
            ],
        },
        "LOCATION": {
            "target": UNIT,
            "traits": [
                Trait(id=ShapeID("smithy.api#enumValue"), value="location"),
            ],
        },
    },
)

DESCRIBE_TOM_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeTomOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "name": {
            "target": TOM_NAME,
        },
        "description": {
            "target": TOM_DESCRIPTION,
        },
        "list": {
            "target": TOM_LIST,
        },
        "category": {
            "target": TOM_CATEGORY,
        },
        "type": {
            "target": TOM_TYPE,
        },
        "referenceCode": {
            "target": TOM_REFERENCE_CODE,
        },
        "status": {
            "target": TOM_STATUS,
        },
        "note": {
            "target": TOM_NOTE,
        },
        "objectCategory": {
            "target": TOM_OBJECT_CATEGORY,
        },
        "documentFiles": {
            "target": UUID_COLLECTION,
        },
    },
)

TOM_SELECT_FILTER = Schema.collection(
    id=ShapeID("borneo#TomSelectFilter"),
    members={
        "search": {
            "target": STRING,
        },
        "category": {
            "target": UNIQUE_STRING_LIST,
        },
        "list": {
            "target": UNIQUE_STRING_LIST,
        },
        "type": {
            "target": UNIQUE_STRING_LIST,
        },
        "status": {
            "target": UNIQUE_STRING_LIST,
        },
        "objectCategory": {
            "target": UNIQUE_STRING_LIST,
        },
        "tomId": {
            "target": UNIQUE_STRING_LIST,
        },
    },
)

LIST_TOMS_INPUT = Schema.collection(
    id=ShapeID("borneo#ListTomsInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": TOM_SELECT_FILTER,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

LIST_TOMS_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListTomsOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "toms": {
            "target": TOM_COLLECTION,
        },
        "nextToken": {
            "target": STRING,
        },
        "total": {
            "target": INTEGER,
        },
    },
)

UPDATE_TOM_INPUT = Schema.collection(
    id=ShapeID("borneo#UpdateTomInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "tomId": {
            "target": TOM_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
        "status": {
            "target": TOM_STATUS,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "note": {
            "target": TOM_NOTE,
        },
        "documentFiles": {
            "target": UUID_COLLECTION,
        },
    },
)

UPDATE_TOM_OUTPUT = Schema.collection(
    id=ShapeID("borneo#UpdateTomOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
)

DESCRIBE_USER_PROFILE_INPUT = Schema.collection(
    id=ShapeID("borneo#DescribeUserProfileInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "userId": {
            "target": USER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
                Trait(id=ShapeID("smithy.api#httpLabel")),
            ],
        },
    },
)

DESCRIBE_USER_PROFILE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeUserProfileOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#UserProfileRecord",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "name": {
            "target": STRING,
        },
        "connectorId": {
            "target": CONNECTOR_ID,
        },
        "email": {
            "target": STRING,
        },
        "connectorUserId": {
            "target": STRING,
        },
        "connectorSourceType": {
            "target": STRING,
        },
        "connectorUsername": {
            "target": STRING,
        },
        "external": {
            "target": BOOLEAN,
        },
        "deletedAt": {
            "target": TIMESTAMP,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "userId": {
            "target": USER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

USER_PROFILE_FILTER = Schema.collection(
    id=ShapeID("borneo#UserProfileFilter"),
    members={
        "search": {
            "target": STRING,
        },
    },
)

LIST_USER_PROFILES_INPUT = Schema.collection(
    id=ShapeID("borneo#ListUserProfilesInput"),
    traits=[
        Trait(id=ShapeID("smithy.api#input")),
    ],
    members={
        "filter": {
            "target": USER_PROFILE_FILTER,
        },
        "select": {
            "target": UNIQUE_STRING_LIST,
        },
        "nextToken": {
            "target": STRING,
        },
        "pageSize": {
            "target": PAGE_SIZE,
        },
        "sort": {
            "target": SORT_RECORDS,
        },
    },
)

USER_PROFILE_RECORD = Schema.collection(
    id=ShapeID("borneo#UserProfileRecord"),
    members={
        "name": {
            "target": STRING,
        },
        "connectorId": {
            "target": CONNECTOR_ID,
        },
        "email": {
            "target": STRING,
        },
        "connectorUserId": {
            "target": STRING,
        },
        "connectorSourceType": {
            "target": STRING,
        },
        "connectorUsername": {
            "target": STRING,
        },
        "external": {
            "target": BOOLEAN,
        },
        "deletedAt": {
            "target": TIMESTAMP,
        },
        "createdAt": {
            "target": TIMESTAMP,
        },
        "updatedAt": {
            "target": TIMESTAMP,
        },
        "userId": {
            "target": USER_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

USER_PROFILE_LIST = Schema.collection(
    id=ShapeID("borneo#UserProfileList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": USER_PROFILE_RECORD,
        },
    },
)

LIST_USER_PROFILES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListUserProfilesOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "total": {
            "target": INTEGER,
        },
        "userProfiles": {
            "target": USER_PROFILE_LIST,
        },
    },
)

MANAGER_OBJECT = Schema.collection(
    id=ShapeID("borneo#ManagerObject"),
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "surname": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "position": {
            "target": STRING,
        },
        "nif": {
            "target": STRING,
        },
        "startDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "endDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "createdBy": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "email": {
            "target": STRING,
        },
        "manager": {
            "target": STRING,
        },
        "department": {
            "target": UUID,
        },
        "referenceId": {
            "target": STRING,
        },
        "departmentObject": {
            "target": DEPARTMENT_OBJECT,
        },
    },
)

DESCRIBE_EMPLOYEE_OUTPUT = Schema.collection(
    id=ShapeID("borneo#DescribeEmployeeOutput"),
    traits=[
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "surname": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "position": {
            "target": STRING,
        },
        "nif": {
            "target": STRING,
        },
        "startDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "endDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "createdBy": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "email": {
            "target": STRING,
        },
        "manager": {
            "target": STRING,
        },
        "department": {
            "target": UUID,
        },
        "referenceId": {
            "target": STRING,
        },
        "departmentObject": {
            "target": DEPARTMENT_OBJECT,
        },
        "managerObject": {
            "target": MANAGER_OBJECT,
        },
    },
)

EMPLOYEE_LIST_MEMBER = Schema.collection(
    id=ShapeID("borneo#EmployeeListMember"),
    members={
        "employeeId": {
            "target": EMPLOYEE_ID,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "name": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "surname": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "position": {
            "target": STRING,
        },
        "nif": {
            "target": STRING,
        },
        "startDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "endDate": {
            "target": STRING,
            "traits": [
                Trait(
                    id=ShapeID("smithy.api#suppress"),
                    value=[
                        "ShouldHaveUsedTimestamp",
                    ],
                ),
            ],
        },
        "createdBy": {
            "target": STRING,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "email": {
            "target": STRING,
        },
        "manager": {
            "target": STRING,
        },
        "department": {
            "target": UUID,
        },
        "referenceId": {
            "target": STRING,
        },
        "departmentObject": {
            "target": DEPARTMENT_OBJECT,
        },
        "managerObject": {
            "target": MANAGER_OBJECT,
        },
        "processingActivities": {
            "target": INTEGER,
        },
    },
)

EMPLOYEE_LIST = Schema.collection(
    id=ShapeID("borneo#EmployeeList"),
    type=ShapeType.LIST,
    members={
        "member": {
            "target": EMPLOYEE_LIST_MEMBER,
        },
    },
)

LIST_EMPLOYEES_OUTPUT = Schema.collection(
    id=ShapeID("borneo#ListEmployeesOutput"),
    traits=[
        Trait(
            id=ShapeID("smithy.synthetic#originalShapeId"),
            value="borneo#EmployeeListOutput",
        ),
        Trait(id=ShapeID("smithy.api#output")),
    ],
    members={
        "nextToken": {
            "target": STRING,
        },
        "employees": {
            "target": EMPLOYEE_LIST,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
        "total": {
            "target": INTEGER,
            "traits": [
                Trait(id=ShapeID("smithy.api#required")),
            ],
        },
    },
)

MANAGER_OBJECT.members["managerObject"] = Schema(
    id=MANAGER_OBJECT.id.with_member("managerObject"),
    type=ShapeType.MEMBER,
    member_target=MANAGER_OBJECT,
    member_index=len(MANAGER_OBJECT.members) + 1,
)
